import{S as Qr,i as Kr,s as Xr,e as s,k as d,w as v,t as o,M as Yr,c as n,d as i,m as p,a,x as b,h as r,b as c,G as e,g as m,y as D,q as w,o as y,B as x,v as Zr,L as Rt}from"../../../chunks/vendor-hf-doc-builder.js";import{D as T}from"../../../chunks/Docstring-hf-doc-builder.js";import{C as ut}from"../../../chunks/CodeBlock-hf-doc-builder.js";import{I as $e}from"../../../chunks/IconCopyLink-hf-doc-builder.js";import{E as Ht}from"../../../chunks/ExampleCodeBlock-hf-doc-builder.js";function Jr(M){let g,$,_,u,P;return u=new ut({props:{code:`from diffusers import VersatileDiffusionPipeline
import torch
import requests
from io import BytesIO
from PIL import Image

# let's download an initial image
url = "https://huggingface.co/datasets/diffusers/images/resolve/main/benz.jpg"

response = requests.get(url)
image = Image.open(BytesIO(response.content)).convert("RGB")
text = "a red car in the sun"

pipe = VersatileDiffusionPipeline.from_pretrained(
    "shi-labs/versatile-diffusion", torch_dtype=torch.float16
)
pipe = pipe.to("cuda")

generator = torch.Generator(device="cuda").manual_seed(0)
text_to_image_strength = 0.75

image = pipe.dual_guided(
    prompt=text, image=image, text_to_image_strength=text_to_image_strength, generator=generator
).images[0]
image.save("./car_variation.png")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> VersatileDiffusionPipeline
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> io <span class="hljs-keyword">import</span> BytesIO
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># let&#x27;s download an initial image</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>url = <span class="hljs-string">&quot;https://huggingface.co/datasets/diffusers/images/resolve/main/benz.jpg&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>response = requests.get(url)
<span class="hljs-meta">&gt;&gt;&gt; </span>image = Image.<span class="hljs-built_in">open</span>(BytesIO(response.content)).convert(<span class="hljs-string">&quot;RGB&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>text = <span class="hljs-string">&quot;a red car in the sun&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = VersatileDiffusionPipeline.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;shi-labs/versatile-diffusion&quot;</span>, torch_dtype=torch.float16
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>generator = torch.Generator(device=<span class="hljs-string">&quot;cuda&quot;</span>).manual_seed(<span class="hljs-number">0</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>text_to_image_strength = <span class="hljs-number">0.75</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>image = pipe.dual_guided(
<span class="hljs-meta">... </span>    prompt=text, image=image, text_to_image_strength=text_to_image_strength, generator=generator
<span class="hljs-meta">... </span>).images[<span class="hljs-number">0</span>]
<span class="hljs-meta">&gt;&gt;&gt; </span>image.save(<span class="hljs-string">&quot;./car_variation.png&quot;</span>)`}}),{c(){g=s("p"),$=o("Examples:"),_=d(),v(u.$$.fragment)},l(l){g=n(l,"P",{});var h=a(g);$=r(h,"Examples:"),h.forEach(i),_=p(l),b(u.$$.fragment,l)},m(l,h){m(l,g,h),e(g,$),m(l,_,h),D(u,l,h),P=!0},p:Rt,i(l){P||(w(u.$$.fragment,l),P=!0)},o(l){y(u.$$.fragment,l),P=!1},d(l){l&&i(g),l&&i(_),x(u,l)}}}function el(M){let g,$,_,u,P;return u=new ut({props:{code:`from diffusers import VersatileDiffusionPipeline
import torch
import requests
from io import BytesIO
from PIL import Image

# let's download an initial image
url = "https://huggingface.co/datasets/diffusers/images/resolve/main/benz.jpg"

response = requests.get(url)
image = Image.open(BytesIO(response.content)).convert("RGB")

pipe = VersatileDiffusionPipeline.from_pretrained(
    "shi-labs/versatile-diffusion", torch_dtype=torch.float16
)
pipe = pipe.to("cuda")

generator = torch.Generator(device="cuda").manual_seed(0)
image = pipe.image_variation(image, generator=generator).images[0]
image.save("./car_variation.png")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> VersatileDiffusionPipeline
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> io <span class="hljs-keyword">import</span> BytesIO
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># let&#x27;s download an initial image</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>url = <span class="hljs-string">&quot;https://huggingface.co/datasets/diffusers/images/resolve/main/benz.jpg&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>response = requests.get(url)
<span class="hljs-meta">&gt;&gt;&gt; </span>image = Image.<span class="hljs-built_in">open</span>(BytesIO(response.content)).convert(<span class="hljs-string">&quot;RGB&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = VersatileDiffusionPipeline.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;shi-labs/versatile-diffusion&quot;</span>, torch_dtype=torch.float16
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>generator = torch.Generator(device=<span class="hljs-string">&quot;cuda&quot;</span>).manual_seed(<span class="hljs-number">0</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>image = pipe.image_variation(image, generator=generator).images[<span class="hljs-number">0</span>]
<span class="hljs-meta">&gt;&gt;&gt; </span>image.save(<span class="hljs-string">&quot;./car_variation.png&quot;</span>)`}}),{c(){g=s("p"),$=o("Examples:"),_=d(),v(u.$$.fragment)},l(l){g=n(l,"P",{});var h=a(g);$=r(h,"Examples:"),h.forEach(i),_=p(l),b(u.$$.fragment,l)},m(l,h){m(l,g,h),e(g,$),m(l,_,h),D(u,l,h),P=!0},p:Rt,i(l){P||(w(u.$$.fragment,l),P=!0)},o(l){y(u.$$.fragment,l),P=!1},d(l){l&&i(g),l&&i(_),x(u,l)}}}function tl(M){let g,$,_,u,P;return u=new ut({props:{code:`from diffusers import VersatileDiffusionPipeline
import torch

pipe = VersatileDiffusionPipeline.from_pretrained(
    "shi-labs/versatile-diffusion", torch_dtype=torch.float16
)
pipe = pipe.to("cuda")

generator = torch.Generator(device="cuda").manual_seed(0)
image = pipe.text_to_image("an astronaut riding on a horse on mars", generator=generator).images[0]
image.save("./astronaut.png")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> VersatileDiffusionPipeline
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = VersatileDiffusionPipeline.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;shi-labs/versatile-diffusion&quot;</span>, torch_dtype=torch.float16
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>generator = torch.Generator(device=<span class="hljs-string">&quot;cuda&quot;</span>).manual_seed(<span class="hljs-number">0</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>image = pipe.text_to_image(<span class="hljs-string">&quot;an astronaut riding on a horse on mars&quot;</span>, generator=generator).images[<span class="hljs-number">0</span>]
<span class="hljs-meta">&gt;&gt;&gt; </span>image.save(<span class="hljs-string">&quot;./astronaut.png&quot;</span>)`}}),{c(){g=s("p"),$=o("Examples:"),_=d(),v(u.$$.fragment)},l(l){g=n(l,"P",{});var h=a(g);$=r(h,"Examples:"),h.forEach(i),_=p(l),b(u.$$.fragment,l)},m(l,h){m(l,g,h),e(g,$),m(l,_,h),D(u,l,h),P=!0},p:Rt,i(l){P||(w(u.$$.fragment,l),P=!0)},o(l){y(u.$$.fragment,l),P=!1},d(l){l&&i(g),l&&i(_),x(u,l)}}}function il(M){let g,$,_,u,P;return u=new ut({props:{code:`from diffusers import VersatileDiffusionTextToImagePipeline
import torch

pipe = VersatileDiffusionTextToImagePipeline.from_pretrained(
    "shi-labs/versatile-diffusion", torch_dtype=torch.float16
)
pipe.remove_unused_weights()
pipe = pipe.to("cuda")

generator = torch.Generator(device="cuda").manual_seed(0)
image = pipe("an astronaut riding on a horse on mars", generator=generator).images[0]
image.save("./astronaut.png")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> VersatileDiffusionTextToImagePipeline
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = VersatileDiffusionTextToImagePipeline.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;shi-labs/versatile-diffusion&quot;</span>, torch_dtype=torch.float16
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.remove_unused_weights()
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>generator = torch.Generator(device=<span class="hljs-string">&quot;cuda&quot;</span>).manual_seed(<span class="hljs-number">0</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>image = pipe(<span class="hljs-string">&quot;an astronaut riding on a horse on mars&quot;</span>, generator=generator).images[<span class="hljs-number">0</span>]
<span class="hljs-meta">&gt;&gt;&gt; </span>image.save(<span class="hljs-string">&quot;./astronaut.png&quot;</span>)`}}),{c(){g=s("p"),$=o("Examples:"),_=d(),v(u.$$.fragment)},l(l){g=n(l,"P",{});var h=a(g);$=r(h,"Examples:"),h.forEach(i),_=p(l),b(u.$$.fragment,l)},m(l,h){m(l,g,h),e(g,$),m(l,_,h),D(u,l,h),P=!0},p:Rt,i(l){P||(w(u.$$.fragment,l),P=!0)},o(l){y(u.$$.fragment,l),P=!1},d(l){l&&i(g),l&&i(_),x(u,l)}}}function sl(M){let g,$,_,u,P;return u=new ut({props:{code:`from diffusers import VersatileDiffusionImageVariationPipeline
import torch
import requests
from io import BytesIO
from PIL import Image

# let's download an initial image
url = "https://huggingface.co/datasets/diffusers/images/resolve/main/benz.jpg"

response = requests.get(url)
image = Image.open(BytesIO(response.content)).convert("RGB")

pipe = VersatileDiffusionImageVariationPipeline.from_pretrained(
    "shi-labs/versatile-diffusion", torch_dtype=torch.float16
)
pipe = pipe.to("cuda")

generator = torch.Generator(device="cuda").manual_seed(0)
image = pipe(image, generator=generator).images[0]
image.save("./car_variation.png")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> VersatileDiffusionImageVariationPipeline
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> io <span class="hljs-keyword">import</span> BytesIO
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># let&#x27;s download an initial image</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>url = <span class="hljs-string">&quot;https://huggingface.co/datasets/diffusers/images/resolve/main/benz.jpg&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>response = requests.get(url)
<span class="hljs-meta">&gt;&gt;&gt; </span>image = Image.<span class="hljs-built_in">open</span>(BytesIO(response.content)).convert(<span class="hljs-string">&quot;RGB&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = VersatileDiffusionImageVariationPipeline.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;shi-labs/versatile-diffusion&quot;</span>, torch_dtype=torch.float16
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>generator = torch.Generator(device=<span class="hljs-string">&quot;cuda&quot;</span>).manual_seed(<span class="hljs-number">0</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>image = pipe(image, generator=generator).images[<span class="hljs-number">0</span>]
<span class="hljs-meta">&gt;&gt;&gt; </span>image.save(<span class="hljs-string">&quot;./car_variation.png&quot;</span>)`}}),{c(){g=s("p"),$=o("Examples:"),_=d(),v(u.$$.fragment)},l(l){g=n(l,"P",{});var h=a(g);$=r(h,"Examples:"),h.forEach(i),_=p(l),b(u.$$.fragment,l)},m(l,h){m(l,g,h),e(g,$),m(l,_,h),D(u,l,h),P=!0},p:Rt,i(l){P||(w(u.$$.fragment,l),P=!0)},o(l){y(u.$$.fragment,l),P=!1},d(l){l&&i(g),l&&i(_),x(u,l)}}}function nl(M){let g,$,_,u,P;return u=new ut({props:{code:`from diffusers import VersatileDiffusionDualGuidedPipeline
import torch
import requests
from io import BytesIO
from PIL import Image

# let's download an initial image
url = "https://huggingface.co/datasets/diffusers/images/resolve/main/benz.jpg"

response = requests.get(url)
image = Image.open(BytesIO(response.content)).convert("RGB")
text = "a red car in the sun"

pipe = VersatileDiffusionDualGuidedPipeline.from_pretrained(
    "shi-labs/versatile-diffusion", torch_dtype=torch.float16
)
pipe.remove_unused_weights()
pipe = pipe.to("cuda")

generator = torch.Generator(device="cuda").manual_seed(0)
text_to_image_strength = 0.75

image = pipe(
    prompt=text, image=image, text_to_image_strength=text_to_image_strength, generator=generator
).images[0]
image.save("./car_variation.png")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> VersatileDiffusionDualGuidedPipeline
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> io <span class="hljs-keyword">import</span> BytesIO
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># let&#x27;s download an initial image</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>url = <span class="hljs-string">&quot;https://huggingface.co/datasets/diffusers/images/resolve/main/benz.jpg&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>response = requests.get(url)
<span class="hljs-meta">&gt;&gt;&gt; </span>image = Image.<span class="hljs-built_in">open</span>(BytesIO(response.content)).convert(<span class="hljs-string">&quot;RGB&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>text = <span class="hljs-string">&quot;a red car in the sun&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = VersatileDiffusionDualGuidedPipeline.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;shi-labs/versatile-diffusion&quot;</span>, torch_dtype=torch.float16
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.remove_unused_weights()
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>generator = torch.Generator(device=<span class="hljs-string">&quot;cuda&quot;</span>).manual_seed(<span class="hljs-number">0</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>text_to_image_strength = <span class="hljs-number">0.75</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>image = pipe(
<span class="hljs-meta">... </span>    prompt=text, image=image, text_to_image_strength=text_to_image_strength, generator=generator
<span class="hljs-meta">... </span>).images[<span class="hljs-number">0</span>]
<span class="hljs-meta">&gt;&gt;&gt; </span>image.save(<span class="hljs-string">&quot;./car_variation.png&quot;</span>)`}}),{c(){g=s("p"),$=o("Examples:"),_=d(),v(u.$$.fragment)},l(l){g=n(l,"P",{});var h=a(g);$=r(h,"Examples:"),h.forEach(i),_=p(l),b(u.$$.fragment,l)},m(l,h){m(l,g,h),e(g,$),m(l,_,h),D(u,l,h),P=!0},p:Rt,i(l){P||(w(u.$$.fragment,l),P=!0)},o(l){y(u.$$.fragment,l),P=!1},d(l){l&&i(g),l&&i(_),x(u,l)}}}function al(M){let g,$,_,u,P,l,h,Qt,Os,Fi,ne,Cs,Ve,Ns,zs,Ui,mt,As,Wi,gt,Kt,Bs,Hi,X,ae,Xt,Ie,Fs,Yt,Us,Ri,ht,ke,Ws,_t,Hs,Rs,Qi,Y,oe,Zt,Te,Qs,Jt,Ks,Ki,L,Xs,vt,Ys,Zs,bt,Js,en,Dt,tn,sn,wt,nn,Xi,yt,ei,an,Yi,xt,on,Zi,G,je,ti,rn,ln,re,dn,ii,pn,cn,fn,Ee,si,un,mn,le,gn,ni,hn,_n,vn,qe,ai,bn,Dn,de,wn,oi,yn,xn,Ji,Z,pe,ri,Se,Pn,li,$n,es,V,Vn,Pt,In,kn,di,Tn,jn,$t,En,qn,Vt,Sn,Mn,It,Ln,Gn,kt,On,Cn,Tt,Nn,zn,pi,An,Bn,ci,Fn,Un,jt,Wn,Hn,ts,Me,is,J,ce,fi,Le,Rn,ui,Qn,ss,k,Ge,Kn,mi,Xn,Yn,Oe,Zn,Et,Jn,ea,ta,fe,Ce,ia,Ne,sa,gi,na,aa,oa,O,ze,ra,hi,la,da,ue,pa,C,Ae,ca,_i,fa,ua,vi,ma,ga,N,Be,ha,bi,_a,va,me,ba,z,Fe,Da,Di,wa,ya,ge,ns,ee,he,wi,Ue,xa,yi,Pa,as,E,We,$a,He,Va,qt,Ia,ka,Ta,A,Re,ja,xi,Ea,qa,_e,Sa,B,Qe,Ma,Pi,La,Ga,$i,Oa,Ca,ve,Ke,Na,Xe,za,Vi,Aa,Ba,os,te,be,Ii,Ye,Fa,ki,Ua,rs,q,Ze,Wa,Je,Ha,St,Ra,Qa,Ka,F,et,Xa,Ti,Ya,Za,De,Ja,U,tt,eo,ji,to,io,Ei,so,no,we,it,ao,st,oo,qi,ro,lo,ls,ie,ye,Si,nt,po,Mi,co,ds,S,at,fo,ot,uo,Mt,mo,go,ho,W,rt,_o,Li,vo,bo,xe,Do,H,lt,wo,Gi,yo,xo,Oi,Po,$o,Pe,dt,Vo,pt,Io,Ci,ko,To,ps;return l=new $e({}),Ie=new $e({}),Te=new $e({}),Se=new $e({}),Me=new ut({props:{code:`from diffusers import VersatileDiffusionPipeline, EulerDiscreteScheduler

pipeline = VersatileDiffusionPipeline.from_pretrained("shi-labs/versatile-diffusion")
pipeline.scheduler = EulerDiscreteScheduler.from_config(pipeline.scheduler.config)

# or
euler_scheduler = EulerDiscreteScheduler.from_pretrained("shi-labs/versatile-diffusion", subfolder="scheduler")
pipeline = VersatileDiffusionPipeline.from_pretrained("shi-labs/versatile-diffusion", scheduler=euler_scheduler)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> VersatileDiffusionPipeline, EulerDiscreteScheduler

<span class="hljs-meta">&gt;&gt;&gt; </span>pipeline = VersatileDiffusionPipeline.from_pretrained(<span class="hljs-string">&quot;shi-labs/versatile-diffusion&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipeline.scheduler = EulerDiscreteScheduler.from_config(pipeline.scheduler.config)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># or</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>euler_scheduler = EulerDiscreteScheduler.from_pretrained(<span class="hljs-string">&quot;shi-labs/versatile-diffusion&quot;</span>, subfolder=<span class="hljs-string">&quot;scheduler&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipeline = VersatileDiffusionPipeline.from_pretrained(<span class="hljs-string">&quot;shi-labs/versatile-diffusion&quot;</span>, scheduler=euler_scheduler)`}}),Le=new $e({}),Ge=new T({props:{name:"class diffusers.VersatileDiffusionPipeline",anchor:"diffusers.VersatileDiffusionPipeline",parameters:[{name:"tokenizer",val:": CLIPTokenizer"},{name:"image_feature_extractor",val:": CLIPImageProcessor"},{name:"text_encoder",val:": CLIPTextModel"},{name:"image_encoder",val:": CLIPVisionModel"},{name:"image_unet",val:": UNet2DConditionModel"},{name:"text_unet",val:": UNet2DConditionModel"},{name:"vae",val:": AutoencoderKL"},{name:"scheduler",val:": typing.Union[diffusers.schedulers.scheduling_ddim.DDIMScheduler, diffusers.schedulers.scheduling_pndm.PNDMScheduler, diffusers.schedulers.scheduling_lms_discrete.LMSDiscreteScheduler]"}],parametersDescription:[{anchor:"diffusers.VersatileDiffusionPipeline.vae",description:`<strong>vae</strong> (<a href="/docs/diffusers/main/en/api/models#diffusers.AutoencoderKL">AutoencoderKL</a>) &#x2014;
Variational Auto-Encoder (VAE) Model to encode and decode images to and from latent representations.`,name:"vae"},{anchor:"diffusers.VersatileDiffusionPipeline.text_encoder",description:`<strong>text_encoder</strong> (<code>CLIPTextModel</code>) &#x2014;
Frozen text-encoder. Stable Diffusion uses the text portion of
<a href="https://huggingface.co/docs/transformers/model_doc/clip#transformers.CLIPTextModel" rel="nofollow">CLIP</a>, specifically
the <a href="https://huggingface.co/openai/clip-vit-large-patch14" rel="nofollow">clip-vit-large-patch14</a> variant.`,name:"text_encoder"},{anchor:"diffusers.VersatileDiffusionPipeline.tokenizer",description:`<strong>tokenizer</strong> (<code>CLIPTokenizer</code>) &#x2014;
Tokenizer of class
<a href="https://huggingface.co/docs/transformers/v4.21.0/en/model_doc/clip#transformers.CLIPTokenizer" rel="nofollow">CLIPTokenizer</a>.`,name:"tokenizer"},{anchor:"diffusers.VersatileDiffusionPipeline.unet",description:'<strong>unet</strong> (<a href="/docs/diffusers/main/en/api/models#diffusers.UNet2DConditionModel">UNet2DConditionModel</a>) &#x2014; Conditional U-Net architecture to denoise the encoded image latents.',name:"unet"},{anchor:"diffusers.VersatileDiffusionPipeline.scheduler",description:`<strong>scheduler</strong> (<a href="/docs/diffusers/main/en/api/schedulers#diffusers.SchedulerMixin">SchedulerMixin</a>) &#x2014;
A scheduler to be used in combination with <code>unet</code> to denoise the encoded image latents. Can be one of
<a href="/docs/diffusers/main/en/api/schedulers#diffusers.DDIMScheduler">DDIMScheduler</a>, <a href="/docs/diffusers/main/en/api/schedulers#diffusers.LMSDiscreteScheduler">LMSDiscreteScheduler</a>, or <a href="/docs/diffusers/main/en/api/schedulers#diffusers.PNDMScheduler">PNDMScheduler</a>.`,name:"scheduler"},{anchor:"diffusers.VersatileDiffusionPipeline.safety_checker",description:`<strong>safety_checker</strong> (<code>StableDiffusionMegaSafetyChecker</code>) &#x2014;
Classification module that estimates whether generated images could be considered offensive or harmful.
Please, refer to the <a href="https://huggingface.co/runwayml/stable-diffusion-v1-5" rel="nofollow">model card</a> for details.`,name:"safety_checker"},{anchor:"diffusers.VersatileDiffusionPipeline.feature_extractor",description:`<strong>feature_extractor</strong> (<code>CLIPFeatureExtractor</code>) &#x2014;
Model that extracts features from generated images to be used as inputs for the <code>safety_checker</code>.`,name:"feature_extractor"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/versatile_diffusion/pipeline_versatile_diffusion.py#L21"}}),Ce=new T({props:{name:"disable_attention_slicing",anchor:"diffusers.VersatileDiffusionPipeline.disable_attention_slicing",parameters:[],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/versatile_diffusion/pipeline_versatile_diffusion.py#L103"}}),ze=new T({props:{name:"dual_guided",anchor:"diffusers.VersatileDiffusionPipeline.dual_guided",parameters:[{name:"prompt",val:": typing.Union[PIL.Image.Image, typing.List[PIL.Image.Image]]"},{name:"image",val:": typing.Union[str, typing.List[str]]"},{name:"text_to_image_strength",val:": float = 0.5"},{name:"height",val:": typing.Optional[int] = None"},{name:"width",val:": typing.Optional[int] = None"},{name:"num_inference_steps",val:": int = 50"},{name:"guidance_scale",val:": float = 7.5"},{name:"num_images_per_prompt",val:": typing.Optional[int] = 1"},{name:"eta",val:": float = 0.0"},{name:"generator",val:": typing.Optional[torch._C.Generator] = None"},{name:"latents",val:": typing.Optional[torch.FloatTensor] = None"},{name:"output_type",val:": typing.Optional[str] = 'pil'"},{name:"return_dict",val:": bool = True"},{name:"callback",val:": typing.Union[typing.Callable[[int, int, torch.FloatTensor], NoneType], NoneType] = None"},{name:"callback_steps",val:": typing.Optional[int] = 1"}],parametersDescription:[{anchor:"diffusers.VersatileDiffusionPipeline.dual_guided.prompt",description:`<strong>prompt</strong> (<code>str</code> or <code>List[str]</code>) &#x2014;
The prompt or prompts to guide the image generation.`,name:"prompt"},{anchor:"diffusers.VersatileDiffusionPipeline.dual_guided.height",description:`<strong>height</strong> (<code>int</code>, <em>optional</em>, defaults to self.image_unet.config.sample_size * self.vae_scale_factor) &#x2014;
The height in pixels of the generated image.`,name:"height"},{anchor:"diffusers.VersatileDiffusionPipeline.dual_guided.width",description:`<strong>width</strong> (<code>int</code>, <em>optional</em>, defaults to self.image_unet.config.sample_size * self.vae_scale_factor) &#x2014;
The width in pixels of the generated image.`,name:"width"},{anchor:"diffusers.VersatileDiffusionPipeline.dual_guided.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 50) &#x2014;
The number of denoising steps. More denoising steps usually lead to a higher quality image at the
expense of slower inference.`,name:"num_inference_steps"},{anchor:"diffusers.VersatileDiffusionPipeline.dual_guided.guidance_scale",description:`<strong>guidance_scale</strong> (<code>float</code>, <em>optional</em>, defaults to 7.5) &#x2014;
Guidance scale as defined in <a href="https://arxiv.org/abs/2207.12598" rel="nofollow">Classifier-Free Diffusion Guidance</a>.
<code>guidance_scale</code> is defined as <code>w</code> of equation 2. of <a href="https://arxiv.org/pdf/2205.11487.pdf" rel="nofollow">Imagen
Paper</a>. Guidance scale is enabled by setting <code>guidance_scale &gt; 1</code>. Higher guidance scale encourages to generate images that are closely linked to the text <code>prompt</code>,
usually at the expense of lower image quality.`,name:"guidance_scale"},{anchor:"diffusers.VersatileDiffusionPipeline.dual_guided.negative_prompt",description:`<strong>negative_prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts not to guide the image generation. Ignored when not using guidance (i.e., ignored
if <code>guidance_scale</code> is less than <code>1</code>).`,name:"negative_prompt"},{anchor:"diffusers.VersatileDiffusionPipeline.dual_guided.num_images_per_prompt",description:`<strong>num_images_per_prompt</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The number of images to generate per prompt.`,name:"num_images_per_prompt"},{anchor:"diffusers.VersatileDiffusionPipeline.dual_guided.eta",description:`<strong>eta</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
Corresponds to parameter eta (&#x3B7;) in the DDIM paper: <a href="https://arxiv.org/abs/2010.02502" rel="nofollow">https://arxiv.org/abs/2010.02502</a>. Only applies to
<a href="/docs/diffusers/main/en/api/schedulers#diffusers.DDIMScheduler">schedulers.DDIMScheduler</a>, will be ignored for others.`,name:"eta"},{anchor:"diffusers.VersatileDiffusionPipeline.dual_guided.generator",description:`<strong>generator</strong> (<code>torch.Generator</code>, <em>optional</em>) &#x2014;
A <a href="https://pytorch.org/docs/stable/generated/torch.Generator.html" rel="nofollow">torch generator</a> to make generation
deterministic.`,name:"generator"},{anchor:"diffusers.VersatileDiffusionPipeline.dual_guided.latents",description:`<strong>latents</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated noisy latents, sampled from a Gaussian distribution, to be used as inputs for image
generation. Can be used to tweak the same generation with different prompts. If not provided, a latents
tensor will ge generated by sampling using the supplied random <code>generator</code>.`,name:"latents"},{anchor:"diffusers.VersatileDiffusionPipeline.dual_guided.output_type",description:`<strong>output_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;pil&quot;</code>) &#x2014;
The output format of the generate image. Choose between
<a href="https://pillow.readthedocs.io/en/stable/" rel="nofollow">PIL</a>: <code>PIL.Image.Image</code> or <code>np.array</code>.`,name:"output_type"},{anchor:"diffusers.VersatileDiffusionPipeline.dual_guided.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/main/en/api/pipelines/stable_diffusion#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput">StableDiffusionPipelineOutput</a> instead of a
plain tuple.`,name:"return_dict"},{anchor:"diffusers.VersatileDiffusionPipeline.dual_guided.callback",description:`<strong>callback</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
A function that will be called every <code>callback_steps</code> steps during inference. The function will be
called with the following arguments: <code>callback(step: int, timestep: int, latents: torch.FloatTensor)</code>.`,name:"callback"},{anchor:"diffusers.VersatileDiffusionPipeline.dual_guided.callback_steps",description:`<strong>callback_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The frequency at which the <code>callback</code> function will be called. If not specified, the callback will be
called at every step.`,name:"callback_steps"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/versatile_diffusion/pipeline_versatile_diffusion.py#L339",returnDescription:`
<p><code>~pipelines.stable_diffusion.ImagePipelineOutput</code> if <code>return_dict</code> is True, otherwise a \`tuple. When
returning a tuple, the first element is a list with the generated images.</p>
`,returnType:`
<p><code>~pipelines.stable_diffusion.ImagePipelineOutput</code> or <code>tuple</code></p>
`}}),ue=new Ht({props:{anchor:"diffusers.VersatileDiffusionPipeline.dual_guided.example",$$slots:{default:[Jr]},$$scope:{ctx:M}}}),Ae=new T({props:{name:"enable_attention_slicing",anchor:"diffusers.VersatileDiffusionPipeline.enable_attention_slicing",parameters:[{name:"slice_size",val:": typing.Union[str, int, NoneType] = 'auto'"}],parametersDescription:[{anchor:"diffusers.VersatileDiffusionPipeline.enable_attention_slicing.slice_size",description:`<strong>slice_size</strong> (<code>str</code> or <code>int</code>, <em>optional</em>, defaults to <code>&quot;auto&quot;</code>) &#x2014;
When <code>&quot;auto&quot;</code>, halves the input to the attention heads, so attention will be computed in two steps. If
a number is provided, uses as many slices as <code>attention_head_dim // slice_size</code>. In this case,
<code>attention_head_dim</code> must be a multiple of <code>slice_size</code>.`,name:"slice_size"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/versatile_diffusion/pipeline_versatile_diffusion.py#L83"}}),Be=new T({props:{name:"image_variation",anchor:"diffusers.VersatileDiffusionPipeline.image_variation",parameters:[{name:"image",val:": typing.Union[torch.FloatTensor, PIL.Image.Image]"},{name:"height",val:": typing.Optional[int] = None"},{name:"width",val:": typing.Optional[int] = None"},{name:"num_inference_steps",val:": int = 50"},{name:"guidance_scale",val:": float = 7.5"},{name:"negative_prompt",val:": typing.Union[str, typing.List[str], NoneType] = None"},{name:"num_images_per_prompt",val:": typing.Optional[int] = 1"},{name:"eta",val:": float = 0.0"},{name:"generator",val:": typing.Optional[torch._C.Generator] = None"},{name:"latents",val:": typing.Optional[torch.FloatTensor] = None"},{name:"output_type",val:": typing.Optional[str] = 'pil'"},{name:"return_dict",val:": bool = True"},{name:"callback",val:": typing.Union[typing.Callable[[int, int, torch.FloatTensor], NoneType], NoneType] = None"},{name:"callback_steps",val:": typing.Optional[int] = 1"}],parametersDescription:[{anchor:"diffusers.VersatileDiffusionPipeline.image_variation.image",description:`<strong>image</strong> (<code>PIL.Image.Image</code>, <code>List[PIL.Image.Image]</code> or <code>torch.Tensor</code>) &#x2014;
The image prompt or prompts to guide the image generation.`,name:"image"},{anchor:"diffusers.VersatileDiffusionPipeline.image_variation.height",description:`<strong>height</strong> (<code>int</code>, <em>optional</em>, defaults to self.image_unet.config.sample_size * self.vae_scale_factor) &#x2014;
The height in pixels of the generated image.`,name:"height"},{anchor:"diffusers.VersatileDiffusionPipeline.image_variation.width",description:`<strong>width</strong> (<code>int</code>, <em>optional</em>, defaults to self.image_unet.config.sample_size * self.vae_scale_factor) &#x2014;
The width in pixels of the generated image.`,name:"width"},{anchor:"diffusers.VersatileDiffusionPipeline.image_variation.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 50) &#x2014;
The number of denoising steps. More denoising steps usually lead to a higher quality image at the
expense of slower inference.`,name:"num_inference_steps"},{anchor:"diffusers.VersatileDiffusionPipeline.image_variation.guidance_scale",description:`<strong>guidance_scale</strong> (<code>float</code>, <em>optional</em>, defaults to 7.5) &#x2014;
Guidance scale as defined in <a href="https://arxiv.org/abs/2207.12598" rel="nofollow">Classifier-Free Diffusion Guidance</a>.
<code>guidance_scale</code> is defined as <code>w</code> of equation 2. of <a href="https://arxiv.org/pdf/2205.11487.pdf" rel="nofollow">Imagen
Paper</a>. Guidance scale is enabled by setting <code>guidance_scale &gt; 1</code>. Higher guidance scale encourages to generate images that are closely linked to the text <code>prompt</code>,
usually at the expense of lower image quality.`,name:"guidance_scale"},{anchor:"diffusers.VersatileDiffusionPipeline.image_variation.negative_prompt",description:`<strong>negative_prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts not to guide the image generation. Ignored when not using guidance (i.e., ignored
if <code>guidance_scale</code> is less than <code>1</code>).`,name:"negative_prompt"},{anchor:"diffusers.VersatileDiffusionPipeline.image_variation.num_images_per_prompt",description:`<strong>num_images_per_prompt</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The number of images to generate per prompt.`,name:"num_images_per_prompt"},{anchor:"diffusers.VersatileDiffusionPipeline.image_variation.eta",description:`<strong>eta</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
Corresponds to parameter eta (&#x3B7;) in the DDIM paper: <a href="https://arxiv.org/abs/2010.02502" rel="nofollow">https://arxiv.org/abs/2010.02502</a>. Only applies to
<a href="/docs/diffusers/main/en/api/schedulers#diffusers.DDIMScheduler">schedulers.DDIMScheduler</a>, will be ignored for others.`,name:"eta"},{anchor:"diffusers.VersatileDiffusionPipeline.image_variation.generator",description:`<strong>generator</strong> (<code>torch.Generator</code>, <em>optional</em>) &#x2014;
A <a href="https://pytorch.org/docs/stable/generated/torch.Generator.html" rel="nofollow">torch generator</a> to make generation
deterministic.`,name:"generator"},{anchor:"diffusers.VersatileDiffusionPipeline.image_variation.latents",description:`<strong>latents</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated noisy latents, sampled from a Gaussian distribution, to be used as inputs for image
generation. Can be used to tweak the same generation with different prompts. If not provided, a latents
tensor will ge generated by sampling using the supplied random <code>generator</code>.`,name:"latents"},{anchor:"diffusers.VersatileDiffusionPipeline.image_variation.output_type",description:`<strong>output_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;pil&quot;</code>) &#x2014;
The output format of the generate image. Choose between
<a href="https://pillow.readthedocs.io/en/stable/" rel="nofollow">PIL</a>: <code>PIL.Image.Image</code> or <code>np.array</code>.`,name:"output_type"},{anchor:"diffusers.VersatileDiffusionPipeline.image_variation.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/main/en/api/pipelines/stable_diffusion#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput">StableDiffusionPipelineOutput</a> instead of a
plain tuple.`,name:"return_dict"},{anchor:"diffusers.VersatileDiffusionPipeline.image_variation.callback",description:`<strong>callback</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
A function that will be called every <code>callback_steps</code> steps during inference. The function will be
called with the following arguments: <code>callback(step: int, timestep: int, latents: torch.FloatTensor)</code>.`,name:"callback"},{anchor:"diffusers.VersatileDiffusionPipeline.image_variation.callback_steps",description:`<strong>callback_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The frequency at which the <code>callback</code> function will be called. If not specified, the callback will be
called at every step.`,name:"callback_steps"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/versatile_diffusion/pipeline_versatile_diffusion.py#L111",returnDescription:`
<p><a
  href="/docs/diffusers/main/en/api/pipelines/stable_diffusion#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput"
>StableDiffusionPipelineOutput</a> if <code>return_dict</code> is True, otherwise a <code>tuple. When returning a tuple, the first element is a list with the generated images, and the second element is a list of </code>bool<code>s denoting whether the corresponding generated image likely represents "not-safe-for-work" (nsfw) content, according to the </code>safety_checker\`.</p>
`,returnType:`
<p><a
  href="/docs/diffusers/main/en/api/pipelines/stable_diffusion#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput"
>StableDiffusionPipelineOutput</a> or <code>tuple</code></p>
`}}),me=new Ht({props:{anchor:"diffusers.VersatileDiffusionPipeline.image_variation.example",$$slots:{default:[el]},$$scope:{ctx:M}}}),Fe=new T({props:{name:"text_to_image",anchor:"diffusers.VersatileDiffusionPipeline.text_to_image",parameters:[{name:"prompt",val:": typing.Union[str, typing.List[str]]"},{name:"height",val:": typing.Optional[int] = None"},{name:"width",val:": typing.Optional[int] = None"},{name:"num_inference_steps",val:": int = 50"},{name:"guidance_scale",val:": float = 7.5"},{name:"negative_prompt",val:": typing.Union[str, typing.List[str], NoneType] = None"},{name:"num_images_per_prompt",val:": typing.Optional[int] = 1"},{name:"eta",val:": float = 0.0"},{name:"generator",val:": typing.Optional[torch._C.Generator] = None"},{name:"latents",val:": typing.Optional[torch.FloatTensor] = None"},{name:"output_type",val:": typing.Optional[str] = 'pil'"},{name:"return_dict",val:": bool = True"},{name:"callback",val:": typing.Union[typing.Callable[[int, int, torch.FloatTensor], NoneType], NoneType] = None"},{name:"callback_steps",val:": typing.Optional[int] = 1"}],parametersDescription:[{anchor:"diffusers.VersatileDiffusionPipeline.text_to_image.prompt",description:`<strong>prompt</strong> (<code>str</code> or <code>List[str]</code>) &#x2014;
The prompt or prompts to guide the image generation.`,name:"prompt"},{anchor:"diffusers.VersatileDiffusionPipeline.text_to_image.height",description:`<strong>height</strong> (<code>int</code>, <em>optional</em>, defaults to self.image_unet.config.sample_size * self.vae_scale_factor) &#x2014;
The height in pixels of the generated image.`,name:"height"},{anchor:"diffusers.VersatileDiffusionPipeline.text_to_image.width",description:`<strong>width</strong> (<code>int</code>, <em>optional</em>, defaults to self.image_unet.config.sample_size * self.vae_scale_factor) &#x2014;
The width in pixels of the generated image.`,name:"width"},{anchor:"diffusers.VersatileDiffusionPipeline.text_to_image.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 50) &#x2014;
The number of denoising steps. More denoising steps usually lead to a higher quality image at the
expense of slower inference.`,name:"num_inference_steps"},{anchor:"diffusers.VersatileDiffusionPipeline.text_to_image.guidance_scale",description:`<strong>guidance_scale</strong> (<code>float</code>, <em>optional</em>, defaults to 7.5) &#x2014;
Guidance scale as defined in <a href="https://arxiv.org/abs/2207.12598" rel="nofollow">Classifier-Free Diffusion Guidance</a>.
<code>guidance_scale</code> is defined as <code>w</code> of equation 2. of <a href="https://arxiv.org/pdf/2205.11487.pdf" rel="nofollow">Imagen
Paper</a>. Guidance scale is enabled by setting <code>guidance_scale &gt; 1</code>. Higher guidance scale encourages to generate images that are closely linked to the text <code>prompt</code>,
usually at the expense of lower image quality.`,name:"guidance_scale"},{anchor:"diffusers.VersatileDiffusionPipeline.text_to_image.negative_prompt",description:`<strong>negative_prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts not to guide the image generation. Ignored when not using guidance (i.e., ignored
if <code>guidance_scale</code> is less than <code>1</code>).`,name:"negative_prompt"},{anchor:"diffusers.VersatileDiffusionPipeline.text_to_image.num_images_per_prompt",description:`<strong>num_images_per_prompt</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The number of images to generate per prompt.`,name:"num_images_per_prompt"},{anchor:"diffusers.VersatileDiffusionPipeline.text_to_image.eta",description:`<strong>eta</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
Corresponds to parameter eta (&#x3B7;) in the DDIM paper: <a href="https://arxiv.org/abs/2010.02502" rel="nofollow">https://arxiv.org/abs/2010.02502</a>. Only applies to
<a href="/docs/diffusers/main/en/api/schedulers#diffusers.DDIMScheduler">schedulers.DDIMScheduler</a>, will be ignored for others.`,name:"eta"},{anchor:"diffusers.VersatileDiffusionPipeline.text_to_image.generator",description:`<strong>generator</strong> (<code>torch.Generator</code>, <em>optional</em>) &#x2014;
A <a href="https://pytorch.org/docs/stable/generated/torch.Generator.html" rel="nofollow">torch generator</a> to make generation
deterministic.`,name:"generator"},{anchor:"diffusers.VersatileDiffusionPipeline.text_to_image.latents",description:`<strong>latents</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated noisy latents, sampled from a Gaussian distribution, to be used as inputs for image
generation. Can be used to tweak the same generation with different prompts. If not provided, a latents
tensor will ge generated by sampling using the supplied random <code>generator</code>.`,name:"latents"},{anchor:"diffusers.VersatileDiffusionPipeline.text_to_image.output_type",description:`<strong>output_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;pil&quot;</code>) &#x2014;
The output format of the generate image. Choose between
<a href="https://pillow.readthedocs.io/en/stable/" rel="nofollow">PIL</a>: <code>PIL.Image.Image</code> or <code>np.array</code>.`,name:"output_type"},{anchor:"diffusers.VersatileDiffusionPipeline.text_to_image.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/main/en/api/pipelines/stable_diffusion#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput">StableDiffusionPipelineOutput</a> instead of a
plain tuple.`,name:"return_dict"},{anchor:"diffusers.VersatileDiffusionPipeline.text_to_image.callback",description:`<strong>callback</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
A function that will be called every <code>callback_steps</code> steps during inference. The function will be
called with the following arguments: <code>callback(step: int, timestep: int, latents: torch.FloatTensor)</code>.`,name:"callback"},{anchor:"diffusers.VersatileDiffusionPipeline.text_to_image.callback_steps",description:`<strong>callback_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The frequency at which the <code>callback</code> function will be called. If not specified, the callback will be
called at every step.`,name:"callback_steps"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/versatile_diffusion/pipeline_versatile_diffusion.py#L227",returnDescription:`
<p><a
  href="/docs/diffusers/main/en/api/pipelines/stable_diffusion#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput"
>StableDiffusionPipelineOutput</a> if <code>return_dict</code> is True, otherwise a <code>tuple. When returning a tuple, the first element is a list with the generated images, and the second element is a list of </code>bool<code>s denoting whether the corresponding generated image likely represents "not-safe-for-work" (nsfw) content, according to the </code>safety_checker\`.</p>
`,returnType:`
<p><a
  href="/docs/diffusers/main/en/api/pipelines/stable_diffusion#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput"
>StableDiffusionPipelineOutput</a> or <code>tuple</code></p>
`}}),ge=new Ht({props:{anchor:"diffusers.VersatileDiffusionPipeline.text_to_image.example",$$slots:{default:[tl]},$$scope:{ctx:M}}}),Ue=new $e({}),We=new T({props:{name:"class diffusers.VersatileDiffusionTextToImagePipeline",anchor:"diffusers.VersatileDiffusionTextToImagePipeline",parameters:[{name:"tokenizer",val:": CLIPTokenizer"},{name:"text_encoder",val:": CLIPTextModelWithProjection"},{name:"image_unet",val:": UNet2DConditionModel"},{name:"text_unet",val:": UNetFlatConditionModel"},{name:"vae",val:": AutoencoderKL"},{name:"scheduler",val:": typing.Union[diffusers.schedulers.scheduling_ddim.DDIMScheduler, diffusers.schedulers.scheduling_pndm.PNDMScheduler, diffusers.schedulers.scheduling_lms_discrete.LMSDiscreteScheduler]"}],parametersDescription:[{anchor:"diffusers.VersatileDiffusionTextToImagePipeline.vqvae",description:`<strong>vqvae</strong> (<a href="/docs/diffusers/main/en/api/models#diffusers.VQModel">VQModel</a>) &#x2014;
Vector-quantized (VQ) Model to encode and decode images to and from latent representations.`,name:"vqvae"},{anchor:"diffusers.VersatileDiffusionTextToImagePipeline.bert",description:`<strong>bert</strong> (<code>LDMBertModel</code>) &#x2014;
Text-encoder model based on <a href="https://huggingface.co/docs/transformers/model_doc/bert" rel="nofollow">BERT</a> architecture.`,name:"bert"},{anchor:"diffusers.VersatileDiffusionTextToImagePipeline.tokenizer",description:`<strong>tokenizer</strong> (<code>transformers.BertTokenizer</code>) &#x2014;
Tokenizer of class
<a href="https://huggingface.co/docs/transformers/model_doc/bert#transformers.BertTokenizer" rel="nofollow">BertTokenizer</a>.`,name:"tokenizer"},{anchor:"diffusers.VersatileDiffusionTextToImagePipeline.unet",description:'<strong>unet</strong> (<a href="/docs/diffusers/main/en/api/models#diffusers.UNet2DConditionModel">UNet2DConditionModel</a>) &#x2014; Conditional U-Net architecture to denoise the encoded image latents.',name:"unet"},{anchor:"diffusers.VersatileDiffusionTextToImagePipeline.scheduler",description:`<strong>scheduler</strong> (<a href="/docs/diffusers/main/en/api/schedulers#diffusers.SchedulerMixin">SchedulerMixin</a>) &#x2014;
A scheduler to be used in combination with <code>unet</code> to denoise the encoded image latents. Can be one of
<a href="/docs/diffusers/main/en/api/schedulers#diffusers.DDIMScheduler">DDIMScheduler</a>, <a href="/docs/diffusers/main/en/api/schedulers#diffusers.LMSDiscreteScheduler">LMSDiscreteScheduler</a>, or <a href="/docs/diffusers/main/en/api/schedulers#diffusers.PNDMScheduler">PNDMScheduler</a>.`,name:"scheduler"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/versatile_diffusion/pipeline_versatile_diffusion_text_to_image.py#L34"}}),Re=new T({props:{name:"__call__",anchor:"diffusers.VersatileDiffusionTextToImagePipeline.__call__",parameters:[{name:"prompt",val:": typing.Union[str, typing.List[str]]"},{name:"height",val:": typing.Optional[int] = None"},{name:"width",val:": typing.Optional[int] = None"},{name:"num_inference_steps",val:": int = 50"},{name:"guidance_scale",val:": float = 7.5"},{name:"negative_prompt",val:": typing.Union[str, typing.List[str], NoneType] = None"},{name:"num_images_per_prompt",val:": typing.Optional[int] = 1"},{name:"eta",val:": float = 0.0"},{name:"generator",val:": typing.Optional[torch._C.Generator] = None"},{name:"latents",val:": typing.Optional[torch.FloatTensor] = None"},{name:"output_type",val:": typing.Optional[str] = 'pil'"},{name:"return_dict",val:": bool = True"},{name:"callback",val:": typing.Union[typing.Callable[[int, int, torch.FloatTensor], NoneType], NoneType] = None"},{name:"callback_steps",val:": typing.Optional[int] = 1"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"diffusers.VersatileDiffusionTextToImagePipeline.__call__.prompt",description:`<strong>prompt</strong> (<code>str</code> or <code>List[str]</code>) &#x2014;
The prompt or prompts to guide the image generation.`,name:"prompt"},{anchor:"diffusers.VersatileDiffusionTextToImagePipeline.__call__.height",description:`<strong>height</strong> (<code>int</code>, <em>optional</em>, defaults to self.image_unet.config.sample_size * self.vae_scale_factor) &#x2014;
The height in pixels of the generated image.`,name:"height"},{anchor:"diffusers.VersatileDiffusionTextToImagePipeline.__call__.width",description:`<strong>width</strong> (<code>int</code>, <em>optional</em>, defaults to self.image_unet.config.sample_size * self.vae_scale_factor) &#x2014;
The width in pixels of the generated image.`,name:"width"},{anchor:"diffusers.VersatileDiffusionTextToImagePipeline.__call__.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 50) &#x2014;
The number of denoising steps. More denoising steps usually lead to a higher quality image at the
expense of slower inference.`,name:"num_inference_steps"},{anchor:"diffusers.VersatileDiffusionTextToImagePipeline.__call__.guidance_scale",description:`<strong>guidance_scale</strong> (<code>float</code>, <em>optional</em>, defaults to 7.5) &#x2014;
Guidance scale as defined in <a href="https://arxiv.org/abs/2207.12598" rel="nofollow">Classifier-Free Diffusion Guidance</a>.
<code>guidance_scale</code> is defined as <code>w</code> of equation 2. of <a href="https://arxiv.org/pdf/2205.11487.pdf" rel="nofollow">Imagen
Paper</a>. Guidance scale is enabled by setting <code>guidance_scale &gt; 1</code>. Higher guidance scale encourages to generate images that are closely linked to the text <code>prompt</code>,
usually at the expense of lower image quality.`,name:"guidance_scale"},{anchor:"diffusers.VersatileDiffusionTextToImagePipeline.__call__.negative_prompt",description:`<strong>negative_prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts not to guide the image generation. Ignored when not using guidance (i.e., ignored
if <code>guidance_scale</code> is less than <code>1</code>).`,name:"negative_prompt"},{anchor:"diffusers.VersatileDiffusionTextToImagePipeline.__call__.num_images_per_prompt",description:`<strong>num_images_per_prompt</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The number of images to generate per prompt.`,name:"num_images_per_prompt"},{anchor:"diffusers.VersatileDiffusionTextToImagePipeline.__call__.eta",description:`<strong>eta</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
Corresponds to parameter eta (&#x3B7;) in the DDIM paper: <a href="https://arxiv.org/abs/2010.02502" rel="nofollow">https://arxiv.org/abs/2010.02502</a>. Only applies to
<a href="/docs/diffusers/main/en/api/schedulers#diffusers.DDIMScheduler">schedulers.DDIMScheduler</a>, will be ignored for others.`,name:"eta"},{anchor:"diffusers.VersatileDiffusionTextToImagePipeline.__call__.generator",description:`<strong>generator</strong> (<code>torch.Generator</code>, <em>optional</em>) &#x2014;
A <a href="https://pytorch.org/docs/stable/generated/torch.Generator.html" rel="nofollow">torch generator</a> to make generation
deterministic.`,name:"generator"},{anchor:"diffusers.VersatileDiffusionTextToImagePipeline.__call__.latents",description:`<strong>latents</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated noisy latents, sampled from a Gaussian distribution, to be used as inputs for image
generation. Can be used to tweak the same generation with different prompts. If not provided, a latents
tensor will ge generated by sampling using the supplied random <code>generator</code>.`,name:"latents"},{anchor:"diffusers.VersatileDiffusionTextToImagePipeline.__call__.output_type",description:`<strong>output_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;pil&quot;</code>) &#x2014;
The output format of the generate image. Choose between
<a href="https://pillow.readthedocs.io/en/stable/" rel="nofollow">PIL</a>: <code>PIL.Image.Image</code> or <code>np.array</code>.`,name:"output_type"},{anchor:"diffusers.VersatileDiffusionTextToImagePipeline.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/main/en/api/pipelines/stable_diffusion#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput">StableDiffusionPipelineOutput</a> instead of a
plain tuple.`,name:"return_dict"},{anchor:"diffusers.VersatileDiffusionTextToImagePipeline.__call__.callback",description:`<strong>callback</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
A function that will be called every <code>callback_steps</code> steps during inference. The function will be
called with the following arguments: <code>callback(step: int, timestep: int, latents: torch.FloatTensor)</code>.`,name:"callback"},{anchor:"diffusers.VersatileDiffusionTextToImagePipeline.__call__.callback_steps",description:`<strong>callback_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The frequency at which the <code>callback</code> function will be called. If not specified, the callback will be
called at every step.`,name:"callback_steps"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/versatile_diffusion/pipeline_versatile_diffusion_text_to_image.py#L344",returnDescription:`
<p><a
  href="/docs/diffusers/main/en/api/pipelines/stable_diffusion#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput"
>StableDiffusionPipelineOutput</a> if <code>return_dict</code> is True, otherwise a <code>tuple. When returning a tuple, the first element is a list with the generated images, and the second element is a list of </code>bool<code>s denoting whether the corresponding generated image likely represents "not-safe-for-work" (nsfw) content, according to the </code>safety_checker\`.</p>
`,returnType:`
<p><a
  href="/docs/diffusers/main/en/api/pipelines/stable_diffusion#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput"
>StableDiffusionPipelineOutput</a> or <code>tuple</code></p>
`}}),_e=new Ht({props:{anchor:"diffusers.VersatileDiffusionTextToImagePipeline.__call__.example",$$slots:{default:[il]},$$scope:{ctx:M}}}),Qe=new T({props:{name:"enable_attention_slicing",anchor:"diffusers.VersatileDiffusionTextToImagePipeline.enable_attention_slicing",parameters:[{name:"slice_size",val:": typing.Union[str, int, NoneType] = 'auto'"}],parametersDescription:[{anchor:"diffusers.VersatileDiffusionTextToImagePipeline.enable_attention_slicing.slice_size",description:`<strong>slice_size</strong> (<code>str</code> or <code>int</code>, <em>optional</em>, defaults to <code>&quot;auto&quot;</code>) &#x2014;
When <code>&quot;auto&quot;</code>, halves the input to the attention heads, so attention will be computed in two steps. If
a number is provided, uses as many slices as <code>attention_head_dim // slice_size</code>. In this case,
<code>attention_head_dim</code> must be a multiple of <code>slice_size</code>.`,name:"slice_size"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/versatile_diffusion/pipeline_versatile_diffusion_text_to_image.py#L102"}}),Ke=new T({props:{name:"disable_attention_slicing",anchor:"diffusers.VersatileDiffusionTextToImagePipeline.disable_attention_slicing",parameters:[],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/versatile_diffusion/pipeline_versatile_diffusion_text_to_image.py#L127"}}),Ye=new $e({}),Ze=new T({props:{name:"class diffusers.VersatileDiffusionImageVariationPipeline",anchor:"diffusers.VersatileDiffusionImageVariationPipeline",parameters:[{name:"image_feature_extractor",val:": CLIPImageProcessor"},{name:"image_encoder",val:": CLIPVisionModelWithProjection"},{name:"image_unet",val:": UNet2DConditionModel"},{name:"vae",val:": AutoencoderKL"},{name:"scheduler",val:": typing.Union[diffusers.schedulers.scheduling_ddim.DDIMScheduler, diffusers.schedulers.scheduling_pndm.PNDMScheduler, diffusers.schedulers.scheduling_lms_discrete.LMSDiscreteScheduler]"}],parametersDescription:[{anchor:"diffusers.VersatileDiffusionImageVariationPipeline.vqvae",description:`<strong>vqvae</strong> (<a href="/docs/diffusers/main/en/api/models#diffusers.VQModel">VQModel</a>) &#x2014;
Vector-quantized (VQ) Model to encode and decode images to and from latent representations.`,name:"vqvae"},{anchor:"diffusers.VersatileDiffusionImageVariationPipeline.bert",description:`<strong>bert</strong> (<code>LDMBertModel</code>) &#x2014;
Text-encoder model based on <a href="https://huggingface.co/docs/transformers/model_doc/bert" rel="nofollow">BERT</a> architecture.`,name:"bert"},{anchor:"diffusers.VersatileDiffusionImageVariationPipeline.tokenizer",description:`<strong>tokenizer</strong> (<code>transformers.BertTokenizer</code>) &#x2014;
Tokenizer of class
<a href="https://huggingface.co/docs/transformers/model_doc/bert#transformers.BertTokenizer" rel="nofollow">BertTokenizer</a>.`,name:"tokenizer"},{anchor:"diffusers.VersatileDiffusionImageVariationPipeline.unet",description:'<strong>unet</strong> (<a href="/docs/diffusers/main/en/api/models#diffusers.UNet2DConditionModel">UNet2DConditionModel</a>) &#x2014; Conditional U-Net architecture to denoise the encoded image latents.',name:"unet"},{anchor:"diffusers.VersatileDiffusionImageVariationPipeline.scheduler",description:`<strong>scheduler</strong> (<a href="/docs/diffusers/main/en/api/schedulers#diffusers.SchedulerMixin">SchedulerMixin</a>) &#x2014;
A scheduler to be used in combination with <code>unet</code> to denoise the encoded image latents. Can be one of
<a href="/docs/diffusers/main/en/api/schedulers#diffusers.DDIMScheduler">DDIMScheduler</a>, <a href="/docs/diffusers/main/en/api/schedulers#diffusers.LMSDiscreteScheduler">LMSDiscreteScheduler</a>, or <a href="/docs/diffusers/main/en/api/schedulers#diffusers.PNDMScheduler">PNDMScheduler</a>.`,name:"scheduler"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/versatile_diffusion/pipeline_versatile_diffusion_image_variation.py#L34"}}),et=new T({props:{name:"__call__",anchor:"diffusers.VersatileDiffusionImageVariationPipeline.__call__",parameters:[{name:"image",val:": typing.Union[PIL.Image.Image, typing.List[PIL.Image.Image], torch.Tensor]"},{name:"height",val:": typing.Optional[int] = None"},{name:"width",val:": typing.Optional[int] = None"},{name:"num_inference_steps",val:": int = 50"},{name:"guidance_scale",val:": float = 7.5"},{name:"negative_prompt",val:": typing.Union[str, typing.List[str], NoneType] = None"},{name:"num_images_per_prompt",val:": typing.Optional[int] = 1"},{name:"eta",val:": float = 0.0"},{name:"generator",val:": typing.Optional[torch._C.Generator] = None"},{name:"latents",val:": typing.Optional[torch.FloatTensor] = None"},{name:"output_type",val:": typing.Optional[str] = 'pil'"},{name:"return_dict",val:": bool = True"},{name:"callback",val:": typing.Union[typing.Callable[[int, int, torch.FloatTensor], NoneType], NoneType] = None"},{name:"callback_steps",val:": typing.Optional[int] = 1"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"diffusers.VersatileDiffusionImageVariationPipeline.__call__.image",description:`<strong>image</strong> (<code>PIL.Image.Image</code>, <code>List[PIL.Image.Image]</code> or <code>torch.Tensor</code>) &#x2014;
The image prompt or prompts to guide the image generation.`,name:"image"},{anchor:"diffusers.VersatileDiffusionImageVariationPipeline.__call__.height",description:`<strong>height</strong> (<code>int</code>, <em>optional</em>, defaults to self.image_unet.config.sample_size * self.vae_scale_factor) &#x2014;
The height in pixels of the generated image.`,name:"height"},{anchor:"diffusers.VersatileDiffusionImageVariationPipeline.__call__.width",description:`<strong>width</strong> (<code>int</code>, <em>optional</em>, defaults to self.image_unet.config.sample_size * self.vae_scale_factor) &#x2014;
The width in pixels of the generated image.`,name:"width"},{anchor:"diffusers.VersatileDiffusionImageVariationPipeline.__call__.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 50) &#x2014;
The number of denoising steps. More denoising steps usually lead to a higher quality image at the
expense of slower inference.`,name:"num_inference_steps"},{anchor:"diffusers.VersatileDiffusionImageVariationPipeline.__call__.guidance_scale",description:`<strong>guidance_scale</strong> (<code>float</code>, <em>optional</em>, defaults to 7.5) &#x2014;
Guidance scale as defined in <a href="https://arxiv.org/abs/2207.12598" rel="nofollow">Classifier-Free Diffusion Guidance</a>.
<code>guidance_scale</code> is defined as <code>w</code> of equation 2. of <a href="https://arxiv.org/pdf/2205.11487.pdf" rel="nofollow">Imagen
Paper</a>. Guidance scale is enabled by setting <code>guidance_scale &gt; 1</code>. Higher guidance scale encourages to generate images that are closely linked to the text <code>prompt</code>,
usually at the expense of lower image quality.`,name:"guidance_scale"},{anchor:"diffusers.VersatileDiffusionImageVariationPipeline.__call__.negative_prompt",description:`<strong>negative_prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts not to guide the image generation. Ignored when not using guidance (i.e., ignored
if <code>guidance_scale</code> is less than <code>1</code>).`,name:"negative_prompt"},{anchor:"diffusers.VersatileDiffusionImageVariationPipeline.__call__.num_images_per_prompt",description:`<strong>num_images_per_prompt</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The number of images to generate per prompt.`,name:"num_images_per_prompt"},{anchor:"diffusers.VersatileDiffusionImageVariationPipeline.__call__.eta",description:`<strong>eta</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
Corresponds to parameter eta (&#x3B7;) in the DDIM paper: <a href="https://arxiv.org/abs/2010.02502" rel="nofollow">https://arxiv.org/abs/2010.02502</a>. Only applies to
<a href="/docs/diffusers/main/en/api/schedulers#diffusers.DDIMScheduler">schedulers.DDIMScheduler</a>, will be ignored for others.`,name:"eta"},{anchor:"diffusers.VersatileDiffusionImageVariationPipeline.__call__.generator",description:`<strong>generator</strong> (<code>torch.Generator</code>, <em>optional</em>) &#x2014;
A <a href="https://pytorch.org/docs/stable/generated/torch.Generator.html" rel="nofollow">torch generator</a> to make generation
deterministic.`,name:"generator"},{anchor:"diffusers.VersatileDiffusionImageVariationPipeline.__call__.latents",description:`<strong>latents</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated noisy latents, sampled from a Gaussian distribution, to be used as inputs for image
generation. Can be used to tweak the same generation with different prompts. If not provided, a latents
tensor will ge generated by sampling using the supplied random <code>generator</code>.`,name:"latents"},{anchor:"diffusers.VersatileDiffusionImageVariationPipeline.__call__.output_type",description:`<strong>output_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;pil&quot;</code>) &#x2014;
The output format of the generate image. Choose between
<a href="https://pillow.readthedocs.io/en/stable/" rel="nofollow">PIL</a>: <code>PIL.Image.Image</code> or <code>np.array</code>.`,name:"output_type"},{anchor:"diffusers.VersatileDiffusionImageVariationPipeline.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/main/en/api/pipelines/stable_diffusion#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput">StableDiffusionPipelineOutput</a> instead of a
plain tuple.`,name:"return_dict"},{anchor:"diffusers.VersatileDiffusionImageVariationPipeline.__call__.callback",description:`<strong>callback</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
A function that will be called every <code>callback_steps</code> steps during inference. The function will be
called with the following arguments: <code>callback(step: int, timestep: int, latents: torch.FloatTensor)</code>.`,name:"callback"},{anchor:"diffusers.VersatileDiffusionImageVariationPipeline.__call__.callback_steps",description:`<strong>callback_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The frequency at which the <code>callback</code> function will be called. If not specified, the callback will be
called at every step.`,name:"callback_steps"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/versatile_diffusion/pipeline_versatile_diffusion_image_variation.py#L282",returnDescription:`
<p><a
  href="/docs/diffusers/main/en/api/pipelines/stable_diffusion#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput"
>StableDiffusionPipelineOutput</a> if <code>return_dict</code> is True, otherwise a <code>tuple. When returning a tuple, the first element is a list with the generated images, and the second element is a list of </code>bool<code>s denoting whether the corresponding generated image likely represents "not-safe-for-work" (nsfw) content, according to the </code>safety_checker\`.</p>
`,returnType:`
<p><a
  href="/docs/diffusers/main/en/api/pipelines/stable_diffusion#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput"
>StableDiffusionPipelineOutput</a> or <code>tuple</code></p>
`}}),De=new Ht({props:{anchor:"diffusers.VersatileDiffusionImageVariationPipeline.__call__.example",$$slots:{default:[sl]},$$scope:{ctx:M}}}),tt=new T({props:{name:"enable_attention_slicing",anchor:"diffusers.VersatileDiffusionImageVariationPipeline.enable_attention_slicing",parameters:[{name:"slice_size",val:": typing.Union[str, int, NoneType] = 'auto'"}],parametersDescription:[{anchor:"diffusers.VersatileDiffusionImageVariationPipeline.enable_attention_slicing.slice_size",description:`<strong>slice_size</strong> (<code>str</code> or <code>int</code>, <em>optional</em>, defaults to <code>&quot;auto&quot;</code>) &#x2014;
When <code>&quot;auto&quot;</code>, halves the input to the attention heads, so attention will be computed in two steps. If
a number is provided, uses as many slices as <code>attention_head_dim // slice_size</code>. In this case,
<code>attention_head_dim</code> must be a multiple of <code>slice_size</code>.`,name:"slice_size"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/versatile_diffusion/pipeline_versatile_diffusion_image_variation.py#L77"}}),it=new T({props:{name:"disable_attention_slicing",anchor:"diffusers.VersatileDiffusionImageVariationPipeline.disable_attention_slicing",parameters:[],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/versatile_diffusion/pipeline_versatile_diffusion_image_variation.py#L102"}}),nt=new $e({}),at=new T({props:{name:"class diffusers.VersatileDiffusionDualGuidedPipeline",anchor:"diffusers.VersatileDiffusionDualGuidedPipeline",parameters:[{name:"tokenizer",val:": CLIPTokenizer"},{name:"image_feature_extractor",val:": CLIPImageProcessor"},{name:"text_encoder",val:": CLIPTextModelWithProjection"},{name:"image_encoder",val:": CLIPVisionModelWithProjection"},{name:"image_unet",val:": UNet2DConditionModel"},{name:"text_unet",val:": UNetFlatConditionModel"},{name:"vae",val:": AutoencoderKL"},{name:"scheduler",val:": typing.Union[diffusers.schedulers.scheduling_ddim.DDIMScheduler, diffusers.schedulers.scheduling_pndm.PNDMScheduler, diffusers.schedulers.scheduling_lms_discrete.LMSDiscreteScheduler]"}],parametersDescription:[{anchor:"diffusers.VersatileDiffusionDualGuidedPipeline.vqvae",description:`<strong>vqvae</strong> (<a href="/docs/diffusers/main/en/api/models#diffusers.VQModel">VQModel</a>) &#x2014;
Vector-quantized (VQ) Model to encode and decode images to and from latent representations.`,name:"vqvae"},{anchor:"diffusers.VersatileDiffusionDualGuidedPipeline.bert",description:`<strong>bert</strong> (<code>LDMBertModel</code>) &#x2014;
Text-encoder model based on <a href="https://huggingface.co/docs/transformers/model_doc/bert" rel="nofollow">BERT</a> architecture.`,name:"bert"},{anchor:"diffusers.VersatileDiffusionDualGuidedPipeline.tokenizer",description:`<strong>tokenizer</strong> (<code>transformers.BertTokenizer</code>) &#x2014;
Tokenizer of class
<a href="https://huggingface.co/docs/transformers/model_doc/bert#transformers.BertTokenizer" rel="nofollow">BertTokenizer</a>.`,name:"tokenizer"},{anchor:"diffusers.VersatileDiffusionDualGuidedPipeline.unet",description:'<strong>unet</strong> (<a href="/docs/diffusers/main/en/api/models#diffusers.UNet2DConditionModel">UNet2DConditionModel</a>) &#x2014; Conditional U-Net architecture to denoise the encoded image latents.',name:"unet"},{anchor:"diffusers.VersatileDiffusionDualGuidedPipeline.scheduler",description:`<strong>scheduler</strong> (<a href="/docs/diffusers/main/en/api/schedulers#diffusers.SchedulerMixin">SchedulerMixin</a>) &#x2014;
A scheduler to be used in combination with <code>unet</code> to denoise the encoded image latents. Can be one of
<a href="/docs/diffusers/main/en/api/schedulers#diffusers.DDIMScheduler">DDIMScheduler</a>, <a href="/docs/diffusers/main/en/api/schedulers#diffusers.LMSDiscreteScheduler">LMSDiscreteScheduler</a>, or <a href="/docs/diffusers/main/en/api/schedulers#diffusers.PNDMScheduler">PNDMScheduler</a>.`,name:"scheduler"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/versatile_diffusion/pipeline_versatile_diffusion_dual_guided.py#L41"}}),rt=new T({props:{name:"__call__",anchor:"diffusers.VersatileDiffusionDualGuidedPipeline.__call__",parameters:[{name:"prompt",val:": typing.Union[PIL.Image.Image, typing.List[PIL.Image.Image]]"},{name:"image",val:": typing.Union[str, typing.List[str]]"},{name:"text_to_image_strength",val:": float = 0.5"},{name:"height",val:": typing.Optional[int] = None"},{name:"width",val:": typing.Optional[int] = None"},{name:"num_inference_steps",val:": int = 50"},{name:"guidance_scale",val:": float = 7.5"},{name:"num_images_per_prompt",val:": typing.Optional[int] = 1"},{name:"eta",val:": float = 0.0"},{name:"generator",val:": typing.Optional[torch._C.Generator] = None"},{name:"latents",val:": typing.Optional[torch.FloatTensor] = None"},{name:"output_type",val:": typing.Optional[str] = 'pil'"},{name:"return_dict",val:": bool = True"},{name:"callback",val:": typing.Union[typing.Callable[[int, int, torch.FloatTensor], NoneType], NoneType] = None"},{name:"callback_steps",val:": typing.Optional[int] = 1"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"diffusers.VersatileDiffusionDualGuidedPipeline.__call__.prompt",description:`<strong>prompt</strong> (<code>str</code> or <code>List[str]</code>) &#x2014;
The prompt or prompts to guide the image generation.`,name:"prompt"},{anchor:"diffusers.VersatileDiffusionDualGuidedPipeline.__call__.height",description:`<strong>height</strong> (<code>int</code>, <em>optional</em>, defaults to self.image_unet.config.sample_size * self.vae_scale_factor) &#x2014;
The height in pixels of the generated image.`,name:"height"},{anchor:"diffusers.VersatileDiffusionDualGuidedPipeline.__call__.width",description:`<strong>width</strong> (<code>int</code>, <em>optional</em>, defaults to self.image_unet.config.sample_size * self.vae_scale_factor) &#x2014;
The width in pixels of the generated image.`,name:"width"},{anchor:"diffusers.VersatileDiffusionDualGuidedPipeline.__call__.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 50) &#x2014;
The number of denoising steps. More denoising steps usually lead to a higher quality image at the
expense of slower inference.`,name:"num_inference_steps"},{anchor:"diffusers.VersatileDiffusionDualGuidedPipeline.__call__.guidance_scale",description:`<strong>guidance_scale</strong> (<code>float</code>, <em>optional</em>, defaults to 7.5) &#x2014;
Guidance scale as defined in <a href="https://arxiv.org/abs/2207.12598" rel="nofollow">Classifier-Free Diffusion Guidance</a>.
<code>guidance_scale</code> is defined as <code>w</code> of equation 2. of <a href="https://arxiv.org/pdf/2205.11487.pdf" rel="nofollow">Imagen
Paper</a>. Guidance scale is enabled by setting <code>guidance_scale &gt; 1</code>. Higher guidance scale encourages to generate images that are closely linked to the text <code>prompt</code>,
usually at the expense of lower image quality.`,name:"guidance_scale"},{anchor:"diffusers.VersatileDiffusionDualGuidedPipeline.__call__.negative_prompt",description:`<strong>negative_prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts not to guide the image generation. Ignored when not using guidance (i.e., ignored
if <code>guidance_scale</code> is less than <code>1</code>).`,name:"negative_prompt"},{anchor:"diffusers.VersatileDiffusionDualGuidedPipeline.__call__.num_images_per_prompt",description:`<strong>num_images_per_prompt</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The number of images to generate per prompt.`,name:"num_images_per_prompt"},{anchor:"diffusers.VersatileDiffusionDualGuidedPipeline.__call__.eta",description:`<strong>eta</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
Corresponds to parameter eta (&#x3B7;) in the DDIM paper: <a href="https://arxiv.org/abs/2010.02502" rel="nofollow">https://arxiv.org/abs/2010.02502</a>. Only applies to
<a href="/docs/diffusers/main/en/api/schedulers#diffusers.DDIMScheduler">schedulers.DDIMScheduler</a>, will be ignored for others.`,name:"eta"},{anchor:"diffusers.VersatileDiffusionDualGuidedPipeline.__call__.generator",description:`<strong>generator</strong> (<code>torch.Generator</code>, <em>optional</em>) &#x2014;
A <a href="https://pytorch.org/docs/stable/generated/torch.Generator.html" rel="nofollow">torch generator</a> to make generation
deterministic.`,name:"generator"},{anchor:"diffusers.VersatileDiffusionDualGuidedPipeline.__call__.latents",description:`<strong>latents</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated noisy latents, sampled from a Gaussian distribution, to be used as inputs for image
generation. Can be used to tweak the same generation with different prompts. If not provided, a latents
tensor will ge generated by sampling using the supplied random <code>generator</code>.`,name:"latents"},{anchor:"diffusers.VersatileDiffusionDualGuidedPipeline.__call__.output_type",description:`<strong>output_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;pil&quot;</code>) &#x2014;
The output format of the generate image. Choose between
<a href="https://pillow.readthedocs.io/en/stable/" rel="nofollow">PIL</a>: <code>PIL.Image.Image</code> or <code>np.array</code>.`,name:"output_type"},{anchor:"diffusers.VersatileDiffusionDualGuidedPipeline.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/main/en/api/pipelines/stable_diffusion#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput">StableDiffusionPipelineOutput</a> instead of a
plain tuple.`,name:"return_dict"},{anchor:"diffusers.VersatileDiffusionDualGuidedPipeline.__call__.callback",description:`<strong>callback</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
A function that will be called every <code>callback_steps</code> steps during inference. The function will be
called with the following arguments: <code>callback(step: int, timestep: int, latents: torch.FloatTensor)</code>.`,name:"callback"},{anchor:"diffusers.VersatileDiffusionDualGuidedPipeline.__call__.callback_steps",description:`<strong>callback_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The frequency at which the <code>callback</code> function will be called. If not specified, the callback will be
called at every step.`,name:"callback_steps"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/versatile_diffusion/pipeline_versatile_diffusion_dual_guided.py#L441",returnDescription:`
<p><code>~pipelines.stable_diffusion.ImagePipelineOutput</code> if <code>return_dict</code> is True, otherwise a \`tuple. When
returning a tuple, the first element is a list with the generated images.</p>
`,returnType:`
<p><code>~pipelines.stable_diffusion.ImagePipelineOutput</code> or <code>tuple</code></p>
`}}),xe=new Ht({props:{anchor:"diffusers.VersatileDiffusionDualGuidedPipeline.__call__.example",$$slots:{default:[nl]},$$scope:{ctx:M}}}),lt=new T({props:{name:"enable_attention_slicing",anchor:"diffusers.VersatileDiffusionDualGuidedPipeline.enable_attention_slicing",parameters:[{name:"slice_size",val:": typing.Union[str, int, NoneType] = 'auto'"}],parametersDescription:[{anchor:"diffusers.VersatileDiffusionDualGuidedPipeline.enable_attention_slicing.slice_size",description:`<strong>slice_size</strong> (<code>str</code> or <code>int</code>, <em>optional</em>, defaults to <code>&quot;auto&quot;</code>) &#x2014;
When <code>&quot;auto&quot;</code>, halves the input to the attention heads, so attention will be computed in two steps. If
a number is provided, uses as many slices as <code>attention_head_dim // slice_size</code>. In this case,
<code>attention_head_dim</code> must be a multiple of <code>slice_size</code>.`,name:"slice_size"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/versatile_diffusion/pipeline_versatile_diffusion_dual_guided.py#L151"}}),dt=new T({props:{name:"disable_attention_slicing",anchor:"diffusers.VersatileDiffusionDualGuidedPipeline.disable_attention_slicing",parameters:[],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/versatile_diffusion/pipeline_versatile_diffusion_dual_guided.py#L176"}}),{c(){g=s("meta"),$=d(),_=s("h1"),u=s("a"),P=s("span"),v(l.$$.fragment),h=d(),Qt=s("span"),Os=o("VersatileDiffusion"),Fi=d(),ne=s("p"),Cs=o("VersatileDiffusion was proposed in "),Ve=s("a"),Ns=o("Versatile Diffusion: Text, Images and Variations All in One Diffusion Model"),zs=o(" by Xingqian Xu, Zhangyang Wang, Eric Zhang, Kai Wang, Humphrey Shi ."),Ui=d(),mt=s("p"),As=o("The abstract of the paper is the following:"),Wi=d(),gt=s("p"),Kt=s("em"),Bs=o("The recent advances in diffusion models have set an impressive milestone in many generation tasks. Trending works such as DALL-E2, Imagen, and Stable Diffusion have attracted great interest in academia and industry. Despite the rapid landscape changes, recent new approaches focus on extensions and performance rather than capacity, thus requiring separate models for separate tasks. In this work, we expand the existing single-flow diffusion pipeline into a multi-flow network, dubbed Versatile Diffusion (VD), that handles text-to-image, image-to-text, image-variation, and text-variation in one unified model. Moreover, we generalize VD to a unified multi-flow multimodal diffusion framework with grouped layers, swappable streams, and other propositions that can process modalities beyond images and text. Through our experiments, we demonstrate that VD and its underlying framework have the following merits: a) VD handles all subtasks with competitive quality; b) VD initiates novel extensions and applications such as disentanglement of style and semantic, image-text dual-guided generation, etc.; c) Through these experiments and applications, VD provides more semantic insights of the generated outputs."),Hi=d(),X=s("h2"),ae=s("a"),Xt=s("span"),v(Ie.$$.fragment),Fs=d(),Yt=s("span"),Us=o("Tips"),Ri=d(),ht=s("ul"),ke=s("li"),Ws=o("VersatileDiffusion is conceptually very similar as "),_t=s("a"),Hs=o("Stable Diffusion"),Rs=o(",  but instead of providing just a image data stream conditioned on text, VersatileDiffusion provides both a image and text data stream and can be conditioned on both text and image."),Qi=d(),Y=s("h3"),oe=s("a"),Zt=s("span"),v(Te.$$.fragment),Qs=d(),Jt=s("span"),Ks=o("*Run VersatileDiffusion*"),Ki=d(),L=s("p"),Xs=o("You can both load the memory intensive \u201Call-in-one\u201D "),vt=s("a"),Ys=o("VersatileDiffusionPipeline"),Zs=o(` that can run all tasks
with the same class as shown in `),bt=s("a"),Js=o("VersatileDiffusionPipeline.text_to_image()"),en=o(", "),Dt=s("a"),tn=o("VersatileDiffusionPipeline.image_variation()"),sn=o(", and "),wt=s("a"),nn=o("VersatileDiffusionPipeline.dual_guided()"),Xi=d(),yt=s("p"),ei=s("strong"),an=o("or"),Yi=d(),xt=s("p"),on=o("You can run the individual pipelines which are much more memory efficient:"),Zi=d(),G=s("ul"),je=s("li"),ti=s("em"),rn=o("Text-to-Image"),ln=o(": "),re=s("a"),dn=o("VersatileDiffusionTextToImagePipeline."),ii=s("strong"),pn=o("call"),cn=o("()"),fn=d(),Ee=s("li"),si=s("em"),un=o("Image Variation"),mn=o(": "),le=s("a"),gn=o("VersatileDiffusionImageVariationPipeline."),ni=s("strong"),hn=o("call"),_n=o("()"),vn=d(),qe=s("li"),ai=s("em"),bn=o("Dual Text and Image Guided Generation"),Dn=o(": "),de=s("a"),wn=o("VersatileDiffusionDualGuidedPipeline."),oi=s("strong"),yn=o("call"),xn=o("()"),Ji=d(),Z=s("h3"),pe=s("a"),ri=s("span"),v(Se.$$.fragment),Pn=d(),li=s("span"),$n=o("*How to load and use different schedulers.*"),es=d(),V=s("p"),Vn=o("The versatile diffusion pipelines uses "),Pt=s("a"),In=o("DDIMScheduler"),kn=o(" scheduler by default. But "),di=s("code"),Tn=o("diffusers"),jn=o(" provides many other schedulers that can be used with the alt diffusion pipeline such as "),$t=s("a"),En=o("PNDMScheduler"),qn=o(", "),Vt=s("a"),Sn=o("LMSDiscreteScheduler"),Mn=o(", "),It=s("a"),Ln=o("EulerDiscreteScheduler"),Gn=o(", "),kt=s("a"),On=o("EulerAncestralDiscreteScheduler"),Cn=o(` etc.
To use a different scheduler, you can either change it via the `),Tt=s("a"),Nn=o("ConfigMixin.from_config()"),zn=o(" method or pass the "),pi=s("code"),An=o("scheduler"),Bn=o(" argument to the "),ci=s("code"),Fn=o("from_pretrained"),Un=o(" method of the pipeline. For example, to use the "),jt=s("a"),Wn=o("EulerDiscreteScheduler"),Hn=o(", you can do the following:"),ts=d(),v(Me.$$.fragment),is=d(),J=s("h2"),ce=s("a"),fi=s("span"),v(Le.$$.fragment),Rn=d(),ui=s("span"),Qn=o("VersatileDiffusionPipeline"),ss=d(),k=s("div"),v(Ge.$$.fragment),Kn=d(),mi=s("p"),Xn=o("Pipeline for text-to-image generation using Stable Diffusion."),Yn=d(),Oe=s("p"),Zn=o("This model inherits from "),Et=s("a"),Jn=o("DiffusionPipeline"),ea=o(`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),ta=d(),fe=s("div"),v(Ce.$$.fragment),ia=d(),Ne=s("p"),sa=o("Disable sliced attention computation. If "),gi=s("code"),na=o("enable_attention_slicing"),aa=o(` was previously invoked, this method will go
back to computing attention in one step.`),oa=d(),O=s("div"),v(ze.$$.fragment),ra=d(),hi=s("p"),la=o("Function invoked when calling the pipeline for generation."),da=d(),v(ue.$$.fragment),pa=d(),C=s("div"),v(Ae.$$.fragment),ca=d(),_i=s("p"),fa=o("Enable sliced attention computation."),ua=d(),vi=s("p"),ma=o(`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),ga=d(),N=s("div"),v(Be.$$.fragment),ha=d(),bi=s("p"),_a=o("Function invoked when calling the pipeline for generation."),va=d(),v(me.$$.fragment),ba=d(),z=s("div"),v(Fe.$$.fragment),Da=d(),Di=s("p"),wa=o("Function invoked when calling the pipeline for generation."),ya=d(),v(ge.$$.fragment),ns=d(),ee=s("h2"),he=s("a"),wi=s("span"),v(Ue.$$.fragment),xa=d(),yi=s("span"),Pa=o("VersatileDiffusionTextToImagePipeline"),as=d(),E=s("div"),v(We.$$.fragment),$a=d(),He=s("p"),Va=o("This model inherits from "),qt=s("a"),Ia=o("DiffusionPipeline"),ka=o(`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),Ta=d(),A=s("div"),v(Re.$$.fragment),ja=d(),xi=s("p"),Ea=o("Function invoked when calling the pipeline for generation."),qa=d(),v(_e.$$.fragment),Sa=d(),B=s("div"),v(Qe.$$.fragment),Ma=d(),Pi=s("p"),La=o("Enable sliced attention computation."),Ga=d(),$i=s("p"),Oa=o(`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),Ca=d(),ve=s("div"),v(Ke.$$.fragment),Na=d(),Xe=s("p"),za=o("Disable sliced attention computation. If "),Vi=s("code"),Aa=o("enable_attention_slicing"),Ba=o(` was previously invoked, this method will go
back to computing attention in one step.`),os=d(),te=s("h2"),be=s("a"),Ii=s("span"),v(Ye.$$.fragment),Fa=d(),ki=s("span"),Ua=o("VersatileDiffusionImageVariationPipeline"),rs=d(),q=s("div"),v(Ze.$$.fragment),Wa=d(),Je=s("p"),Ha=o("This model inherits from "),St=s("a"),Ra=o("DiffusionPipeline"),Qa=o(`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),Ka=d(),F=s("div"),v(et.$$.fragment),Xa=d(),Ti=s("p"),Ya=o("Function invoked when calling the pipeline for generation."),Za=d(),v(De.$$.fragment),Ja=d(),U=s("div"),v(tt.$$.fragment),eo=d(),ji=s("p"),to=o("Enable sliced attention computation."),io=d(),Ei=s("p"),so=o(`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),no=d(),we=s("div"),v(it.$$.fragment),ao=d(),st=s("p"),oo=o("Disable sliced attention computation. If "),qi=s("code"),ro=o("enable_attention_slicing"),lo=o(` was previously invoked, this method will go
back to computing attention in one step.`),ls=d(),ie=s("h2"),ye=s("a"),Si=s("span"),v(nt.$$.fragment),po=d(),Mi=s("span"),co=o("VersatileDiffusionDualGuidedPipeline"),ds=d(),S=s("div"),v(at.$$.fragment),fo=d(),ot=s("p"),uo=o("This model inherits from "),Mt=s("a"),mo=o("DiffusionPipeline"),go=o(`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),ho=d(),W=s("div"),v(rt.$$.fragment),_o=d(),Li=s("p"),vo=o("Function invoked when calling the pipeline for generation."),bo=d(),v(xe.$$.fragment),Do=d(),H=s("div"),v(lt.$$.fragment),wo=d(),Gi=s("p"),yo=o("Enable sliced attention computation."),xo=d(),Oi=s("p"),Po=o(`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),$o=d(),Pe=s("div"),v(dt.$$.fragment),Vo=d(),pt=s("p"),Io=o("Disable sliced attention computation. If "),Ci=s("code"),ko=o("enable_attention_slicing"),To=o(` was previously invoked, this method will go
back to computing attention in one step.`),this.h()},l(t){const f=Yr('[data-svelte="svelte-1phssyn"]',document.head);g=n(f,"META",{name:!0,content:!0}),f.forEach(i),$=p(t),_=n(t,"H1",{class:!0});var ct=a(_);u=n(ct,"A",{id:!0,class:!0,href:!0});var Ni=a(u);P=n(Ni,"SPAN",{});var zi=a(P);b(l.$$.fragment,zi),zi.forEach(i),Ni.forEach(i),h=p(ct),Qt=n(ct,"SPAN",{});var Ai=a(Qt);Os=r(Ai,"VersatileDiffusion"),Ai.forEach(i),ct.forEach(i),Fi=p(t),ne=n(t,"P",{});var ft=a(ne);Cs=r(ft,"VersatileDiffusion was proposed in "),Ve=n(ft,"A",{href:!0,rel:!0});var Bi=a(Ve);Ns=r(Bi,"Versatile Diffusion: Text, Images and Variations All in One Diffusion Model"),Bi.forEach(i),zs=r(ft," by Xingqian Xu, Zhangyang Wang, Eric Zhang, Kai Wang, Humphrey Shi ."),ft.forEach(i),Ui=p(t),mt=n(t,"P",{});var jo=a(mt);As=r(jo,"The abstract of the paper is the following:"),jo.forEach(i),Wi=p(t),gt=n(t,"P",{});var Eo=a(gt);Kt=n(Eo,"EM",{});var qo=a(Kt);Bs=r(qo,"The recent advances in diffusion models have set an impressive milestone in many generation tasks. Trending works such as DALL-E2, Imagen, and Stable Diffusion have attracted great interest in academia and industry. Despite the rapid landscape changes, recent new approaches focus on extensions and performance rather than capacity, thus requiring separate models for separate tasks. In this work, we expand the existing single-flow diffusion pipeline into a multi-flow network, dubbed Versatile Diffusion (VD), that handles text-to-image, image-to-text, image-variation, and text-variation in one unified model. Moreover, we generalize VD to a unified multi-flow multimodal diffusion framework with grouped layers, swappable streams, and other propositions that can process modalities beyond images and text. Through our experiments, we demonstrate that VD and its underlying framework have the following merits: a) VD handles all subtasks with competitive quality; b) VD initiates novel extensions and applications such as disentanglement of style and semantic, image-text dual-guided generation, etc.; c) Through these experiments and applications, VD provides more semantic insights of the generated outputs."),qo.forEach(i),Eo.forEach(i),Hi=p(t),X=n(t,"H2",{class:!0});var cs=a(X);ae=n(cs,"A",{id:!0,class:!0,href:!0});var So=a(ae);Xt=n(So,"SPAN",{});var Mo=a(Xt);b(Ie.$$.fragment,Mo),Mo.forEach(i),So.forEach(i),Fs=p(cs),Yt=n(cs,"SPAN",{});var Lo=a(Yt);Us=r(Lo,"Tips"),Lo.forEach(i),cs.forEach(i),Ri=p(t),ht=n(t,"UL",{});var Go=a(ht);ke=n(Go,"LI",{});var fs=a(ke);Ws=r(fs,"VersatileDiffusion is conceptually very similar as "),_t=n(fs,"A",{href:!0});var Oo=a(_t);Hs=r(Oo,"Stable Diffusion"),Oo.forEach(i),Rs=r(fs,",  but instead of providing just a image data stream conditioned on text, VersatileDiffusion provides both a image and text data stream and can be conditioned on both text and image."),fs.forEach(i),Go.forEach(i),Qi=p(t),Y=n(t,"H3",{class:!0});var us=a(Y);oe=n(us,"A",{id:!0,class:!0,href:!0});var Co=a(oe);Zt=n(Co,"SPAN",{});var No=a(Zt);b(Te.$$.fragment,No),No.forEach(i),Co.forEach(i),Qs=p(us),Jt=n(us,"SPAN",{});var zo=a(Jt);Ks=r(zo,"*Run VersatileDiffusion*"),zo.forEach(i),us.forEach(i),Ki=p(t),L=n(t,"P",{});var se=a(L);Xs=r(se,"You can both load the memory intensive \u201Call-in-one\u201D "),vt=n(se,"A",{href:!0});var Ao=a(vt);Ys=r(Ao,"VersatileDiffusionPipeline"),Ao.forEach(i),Zs=r(se,` that can run all tasks
with the same class as shown in `),bt=n(se,"A",{href:!0});var Bo=a(bt);Js=r(Bo,"VersatileDiffusionPipeline.text_to_image()"),Bo.forEach(i),en=r(se,", "),Dt=n(se,"A",{href:!0});var Fo=a(Dt);tn=r(Fo,"VersatileDiffusionPipeline.image_variation()"),Fo.forEach(i),sn=r(se,", and "),wt=n(se,"A",{href:!0});var Uo=a(wt);nn=r(Uo,"VersatileDiffusionPipeline.dual_guided()"),Uo.forEach(i),se.forEach(i),Xi=p(t),yt=n(t,"P",{});var Wo=a(yt);ei=n(Wo,"STRONG",{});var Ho=a(ei);an=r(Ho,"or"),Ho.forEach(i),Wo.forEach(i),Yi=p(t),xt=n(t,"P",{});var Ro=a(xt);on=r(Ro,"You can run the individual pipelines which are much more memory efficient:"),Ro.forEach(i),Zi=p(t),G=n(t,"UL",{});var Lt=a(G);je=n(Lt,"LI",{});var ms=a(je);ti=n(ms,"EM",{});var Qo=a(ti);rn=r(Qo,"Text-to-Image"),Qo.forEach(i),ln=r(ms,": "),re=n(ms,"A",{href:!0});var gs=a(re);dn=r(gs,"VersatileDiffusionTextToImagePipeline."),ii=n(gs,"STRONG",{});var Ko=a(ii);pn=r(Ko,"call"),Ko.forEach(i),cn=r(gs,"()"),gs.forEach(i),ms.forEach(i),fn=p(Lt),Ee=n(Lt,"LI",{});var hs=a(Ee);si=n(hs,"EM",{});var Xo=a(si);un=r(Xo,"Image Variation"),Xo.forEach(i),mn=r(hs,": "),le=n(hs,"A",{href:!0});var _s=a(le);gn=r(_s,"VersatileDiffusionImageVariationPipeline."),ni=n(_s,"STRONG",{});var Yo=a(ni);hn=r(Yo,"call"),Yo.forEach(i),_n=r(_s,"()"),_s.forEach(i),hs.forEach(i),vn=p(Lt),qe=n(Lt,"LI",{});var vs=a(qe);ai=n(vs,"EM",{});var Zo=a(ai);bn=r(Zo,"Dual Text and Image Guided Generation"),Zo.forEach(i),Dn=r(vs,": "),de=n(vs,"A",{href:!0});var bs=a(de);wn=r(bs,"VersatileDiffusionDualGuidedPipeline."),oi=n(bs,"STRONG",{});var Jo=a(oi);yn=r(Jo,"call"),Jo.forEach(i),xn=r(bs,"()"),bs.forEach(i),vs.forEach(i),Lt.forEach(i),Ji=p(t),Z=n(t,"H3",{class:!0});var Ds=a(Z);pe=n(Ds,"A",{id:!0,class:!0,href:!0});var er=a(pe);ri=n(er,"SPAN",{});var tr=a(ri);b(Se.$$.fragment,tr),tr.forEach(i),er.forEach(i),Pn=p(Ds),li=n(Ds,"SPAN",{});var ir=a(li);$n=r(ir,"*How to load and use different schedulers.*"),ir.forEach(i),Ds.forEach(i),es=p(t),V=n(t,"P",{});var I=a(V);Vn=r(I,"The versatile diffusion pipelines uses "),Pt=n(I,"A",{href:!0});var sr=a(Pt);In=r(sr,"DDIMScheduler"),sr.forEach(i),kn=r(I," scheduler by default. But "),di=n(I,"CODE",{});var nr=a(di);Tn=r(nr,"diffusers"),nr.forEach(i),jn=r(I," provides many other schedulers that can be used with the alt diffusion pipeline such as "),$t=n(I,"A",{href:!0});var ar=a($t);En=r(ar,"PNDMScheduler"),ar.forEach(i),qn=r(I,", "),Vt=n(I,"A",{href:!0});var or=a(Vt);Sn=r(or,"LMSDiscreteScheduler"),or.forEach(i),Mn=r(I,", "),It=n(I,"A",{href:!0});var rr=a(It);Ln=r(rr,"EulerDiscreteScheduler"),rr.forEach(i),Gn=r(I,", "),kt=n(I,"A",{href:!0});var lr=a(kt);On=r(lr,"EulerAncestralDiscreteScheduler"),lr.forEach(i),Cn=r(I,` etc.
To use a different scheduler, you can either change it via the `),Tt=n(I,"A",{href:!0});var dr=a(Tt);Nn=r(dr,"ConfigMixin.from_config()"),dr.forEach(i),zn=r(I," method or pass the "),pi=n(I,"CODE",{});var pr=a(pi);An=r(pr,"scheduler"),pr.forEach(i),Bn=r(I," argument to the "),ci=n(I,"CODE",{});var cr=a(ci);Fn=r(cr,"from_pretrained"),cr.forEach(i),Un=r(I," method of the pipeline. For example, to use the "),jt=n(I,"A",{href:!0});var fr=a(jt);Wn=r(fr,"EulerDiscreteScheduler"),fr.forEach(i),Hn=r(I,", you can do the following:"),I.forEach(i),ts=p(t),b(Me.$$.fragment,t),is=p(t),J=n(t,"H2",{class:!0});var ws=a(J);ce=n(ws,"A",{id:!0,class:!0,href:!0});var ur=a(ce);fi=n(ur,"SPAN",{});var mr=a(fi);b(Le.$$.fragment,mr),mr.forEach(i),ur.forEach(i),Rn=p(ws),ui=n(ws,"SPAN",{});var gr=a(ui);Qn=r(gr,"VersatileDiffusionPipeline"),gr.forEach(i),ws.forEach(i),ss=p(t),k=n(t,"DIV",{class:!0});var j=a(k);b(Ge.$$.fragment,j),Kn=p(j),mi=n(j,"P",{});var hr=a(mi);Xn=r(hr,"Pipeline for text-to-image generation using Stable Diffusion."),hr.forEach(i),Yn=p(j),Oe=n(j,"P",{});var ys=a(Oe);Zn=r(ys,"This model inherits from "),Et=n(ys,"A",{href:!0});var _r=a(Et);Jn=r(_r,"DiffusionPipeline"),_r.forEach(i),ea=r(ys,`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),ys.forEach(i),ta=p(j),fe=n(j,"DIV",{class:!0});var xs=a(fe);b(Ce.$$.fragment,xs),ia=p(xs),Ne=n(xs,"P",{});var Ps=a(Ne);sa=r(Ps,"Disable sliced attention computation. If "),gi=n(Ps,"CODE",{});var vr=a(gi);na=r(vr,"enable_attention_slicing"),vr.forEach(i),aa=r(Ps,` was previously invoked, this method will go
back to computing attention in one step.`),Ps.forEach(i),xs.forEach(i),oa=p(j),O=n(j,"DIV",{class:!0});var Gt=a(O);b(ze.$$.fragment,Gt),ra=p(Gt),hi=n(Gt,"P",{});var br=a(hi);la=r(br,"Function invoked when calling the pipeline for generation."),br.forEach(i),da=p(Gt),b(ue.$$.fragment,Gt),Gt.forEach(i),pa=p(j),C=n(j,"DIV",{class:!0});var Ot=a(C);b(Ae.$$.fragment,Ot),ca=p(Ot),_i=n(Ot,"P",{});var Dr=a(_i);fa=r(Dr,"Enable sliced attention computation."),Dr.forEach(i),ua=p(Ot),vi=n(Ot,"P",{});var wr=a(vi);ma=r(wr,`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),wr.forEach(i),Ot.forEach(i),ga=p(j),N=n(j,"DIV",{class:!0});var Ct=a(N);b(Be.$$.fragment,Ct),ha=p(Ct),bi=n(Ct,"P",{});var yr=a(bi);_a=r(yr,"Function invoked when calling the pipeline for generation."),yr.forEach(i),va=p(Ct),b(me.$$.fragment,Ct),Ct.forEach(i),ba=p(j),z=n(j,"DIV",{class:!0});var Nt=a(z);b(Fe.$$.fragment,Nt),Da=p(Nt),Di=n(Nt,"P",{});var xr=a(Di);wa=r(xr,"Function invoked when calling the pipeline for generation."),xr.forEach(i),ya=p(Nt),b(ge.$$.fragment,Nt),Nt.forEach(i),j.forEach(i),ns=p(t),ee=n(t,"H2",{class:!0});var $s=a(ee);he=n($s,"A",{id:!0,class:!0,href:!0});var Pr=a(he);wi=n(Pr,"SPAN",{});var $r=a(wi);b(Ue.$$.fragment,$r),$r.forEach(i),Pr.forEach(i),xa=p($s),yi=n($s,"SPAN",{});var Vr=a(yi);Pa=r(Vr,"VersatileDiffusionTextToImagePipeline"),Vr.forEach(i),$s.forEach(i),as=p(t),E=n(t,"DIV",{class:!0});var R=a(E);b(We.$$.fragment,R),$a=p(R),He=n(R,"P",{});var Vs=a(He);Va=r(Vs,"This model inherits from "),qt=n(Vs,"A",{href:!0});var Ir=a(qt);Ia=r(Ir,"DiffusionPipeline"),Ir.forEach(i),ka=r(Vs,`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),Vs.forEach(i),Ta=p(R),A=n(R,"DIV",{class:!0});var zt=a(A);b(Re.$$.fragment,zt),ja=p(zt),xi=n(zt,"P",{});var kr=a(xi);Ea=r(kr,"Function invoked when calling the pipeline for generation."),kr.forEach(i),qa=p(zt),b(_e.$$.fragment,zt),zt.forEach(i),Sa=p(R),B=n(R,"DIV",{class:!0});var At=a(B);b(Qe.$$.fragment,At),Ma=p(At),Pi=n(At,"P",{});var Tr=a(Pi);La=r(Tr,"Enable sliced attention computation."),Tr.forEach(i),Ga=p(At),$i=n(At,"P",{});var jr=a($i);Oa=r(jr,`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),jr.forEach(i),At.forEach(i),Ca=p(R),ve=n(R,"DIV",{class:!0});var Is=a(ve);b(Ke.$$.fragment,Is),Na=p(Is),Xe=n(Is,"P",{});var ks=a(Xe);za=r(ks,"Disable sliced attention computation. If "),Vi=n(ks,"CODE",{});var Er=a(Vi);Aa=r(Er,"enable_attention_slicing"),Er.forEach(i),Ba=r(ks,` was previously invoked, this method will go
back to computing attention in one step.`),ks.forEach(i),Is.forEach(i),R.forEach(i),os=p(t),te=n(t,"H2",{class:!0});var Ts=a(te);be=n(Ts,"A",{id:!0,class:!0,href:!0});var qr=a(be);Ii=n(qr,"SPAN",{});var Sr=a(Ii);b(Ye.$$.fragment,Sr),Sr.forEach(i),qr.forEach(i),Fa=p(Ts),ki=n(Ts,"SPAN",{});var Mr=a(ki);Ua=r(Mr,"VersatileDiffusionImageVariationPipeline"),Mr.forEach(i),Ts.forEach(i),rs=p(t),q=n(t,"DIV",{class:!0});var Q=a(q);b(Ze.$$.fragment,Q),Wa=p(Q),Je=n(Q,"P",{});var js=a(Je);Ha=r(js,"This model inherits from "),St=n(js,"A",{href:!0});var Lr=a(St);Ra=r(Lr,"DiffusionPipeline"),Lr.forEach(i),Qa=r(js,`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),js.forEach(i),Ka=p(Q),F=n(Q,"DIV",{class:!0});var Bt=a(F);b(et.$$.fragment,Bt),Xa=p(Bt),Ti=n(Bt,"P",{});var Gr=a(Ti);Ya=r(Gr,"Function invoked when calling the pipeline for generation."),Gr.forEach(i),Za=p(Bt),b(De.$$.fragment,Bt),Bt.forEach(i),Ja=p(Q),U=n(Q,"DIV",{class:!0});var Ft=a(U);b(tt.$$.fragment,Ft),eo=p(Ft),ji=n(Ft,"P",{});var Or=a(ji);to=r(Or,"Enable sliced attention computation."),Or.forEach(i),io=p(Ft),Ei=n(Ft,"P",{});var Cr=a(Ei);so=r(Cr,`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),Cr.forEach(i),Ft.forEach(i),no=p(Q),we=n(Q,"DIV",{class:!0});var Es=a(we);b(it.$$.fragment,Es),ao=p(Es),st=n(Es,"P",{});var qs=a(st);oo=r(qs,"Disable sliced attention computation. If "),qi=n(qs,"CODE",{});var Nr=a(qi);ro=r(Nr,"enable_attention_slicing"),Nr.forEach(i),lo=r(qs,` was previously invoked, this method will go
back to computing attention in one step.`),qs.forEach(i),Es.forEach(i),Q.forEach(i),ls=p(t),ie=n(t,"H2",{class:!0});var Ss=a(ie);ye=n(Ss,"A",{id:!0,class:!0,href:!0});var zr=a(ye);Si=n(zr,"SPAN",{});var Ar=a(Si);b(nt.$$.fragment,Ar),Ar.forEach(i),zr.forEach(i),po=p(Ss),Mi=n(Ss,"SPAN",{});var Br=a(Mi);co=r(Br,"VersatileDiffusionDualGuidedPipeline"),Br.forEach(i),Ss.forEach(i),ds=p(t),S=n(t,"DIV",{class:!0});var K=a(S);b(at.$$.fragment,K),fo=p(K),ot=n(K,"P",{});var Ms=a(ot);uo=r(Ms,"This model inherits from "),Mt=n(Ms,"A",{href:!0});var Fr=a(Mt);mo=r(Fr,"DiffusionPipeline"),Fr.forEach(i),go=r(Ms,`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),Ms.forEach(i),ho=p(K),W=n(K,"DIV",{class:!0});var Ut=a(W);b(rt.$$.fragment,Ut),_o=p(Ut),Li=n(Ut,"P",{});var Ur=a(Li);vo=r(Ur,"Function invoked when calling the pipeline for generation."),Ur.forEach(i),bo=p(Ut),b(xe.$$.fragment,Ut),Ut.forEach(i),Do=p(K),H=n(K,"DIV",{class:!0});var Wt=a(H);b(lt.$$.fragment,Wt),wo=p(Wt),Gi=n(Wt,"P",{});var Wr=a(Gi);yo=r(Wr,"Enable sliced attention computation."),Wr.forEach(i),xo=p(Wt),Oi=n(Wt,"P",{});var Hr=a(Oi);Po=r(Hr,`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),Hr.forEach(i),Wt.forEach(i),$o=p(K),Pe=n(K,"DIV",{class:!0});var Ls=a(Pe);b(dt.$$.fragment,Ls),Vo=p(Ls),pt=n(Ls,"P",{});var Gs=a(pt);Io=r(Gs,"Disable sliced attention computation. If "),Ci=n(Gs,"CODE",{});var Rr=a(Ci);ko=r(Rr,"enable_attention_slicing"),Rr.forEach(i),To=r(Gs,` was previously invoked, this method will go
back to computing attention in one step.`),Gs.forEach(i),Ls.forEach(i),K.forEach(i),this.h()},h(){c(g,"name","hf:doc:metadata"),c(g,"content",JSON.stringify(ol)),c(u,"id","versatilediffusion"),c(u,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(u,"href","#versatilediffusion"),c(_,"class","relative group"),c(Ve,"href","https://arxiv.org/abs/2211.08332"),c(Ve,"rel","nofollow"),c(ae,"id","tips"),c(ae,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(ae,"href","#tips"),c(X,"class","relative group"),c(_t,"href","./api/pipelines/stable_diffusion"),c(oe,"id","run-versatilediffusion"),c(oe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(oe,"href","#run-versatilediffusion"),c(Y,"class","relative group"),c(vt,"href","/docs/diffusers/main/en/api/pipelines/versatile_diffusion#diffusers.VersatileDiffusionPipeline"),c(bt,"href","/docs/diffusers/main/en/api/pipelines/versatile_diffusion#diffusers.VersatileDiffusionPipeline.text_to_image"),c(Dt,"href","/docs/diffusers/main/en/api/pipelines/versatile_diffusion#diffusers.VersatileDiffusionPipeline.image_variation"),c(wt,"href","/docs/diffusers/main/en/api/pipelines/versatile_diffusion#diffusers.VersatileDiffusionPipeline.dual_guided"),c(re,"href","/docs/diffusers/main/en/api/pipelines/versatile_diffusion#diffusers.VersatileDiffusionTextToImagePipeline.__call__"),c(le,"href","/docs/diffusers/main/en/api/pipelines/versatile_diffusion#diffusers.VersatileDiffusionImageVariationPipeline.__call__"),c(de,"href","/docs/diffusers/main/en/api/pipelines/versatile_diffusion#diffusers.VersatileDiffusionDualGuidedPipeline.__call__"),c(pe,"id","how-to-load-and-use-different-schedulers"),c(pe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(pe,"href","#how-to-load-and-use-different-schedulers"),c(Z,"class","relative group"),c(Pt,"href","/docs/diffusers/main/en/api/schedulers#diffusers.DDIMScheduler"),c($t,"href","/docs/diffusers/main/en/api/schedulers#diffusers.PNDMScheduler"),c(Vt,"href","/docs/diffusers/main/en/api/schedulers#diffusers.LMSDiscreteScheduler"),c(It,"href","/docs/diffusers/main/en/api/schedulers#diffusers.EulerDiscreteScheduler"),c(kt,"href","/docs/diffusers/main/en/api/schedulers#diffusers.EulerAncestralDiscreteScheduler"),c(Tt,"href","/docs/diffusers/main/en/using-diffusers/configuration#diffusers.ConfigMixin.from_config"),c(jt,"href","/docs/diffusers/main/en/api/schedulers#diffusers.EulerDiscreteScheduler"),c(ce,"id","diffusers.VersatileDiffusionPipeline"),c(ce,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(ce,"href","#diffusers.VersatileDiffusionPipeline"),c(J,"class","relative group"),c(Et,"href","/docs/diffusers/main/en/api/diffusion_pipeline#diffusers.DiffusionPipeline"),c(fe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(O,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(C,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(N,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(z,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(k,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(he,"id","diffusers.VersatileDiffusionTextToImagePipeline"),c(he,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(he,"href","#diffusers.VersatileDiffusionTextToImagePipeline"),c(ee,"class","relative group"),c(qt,"href","/docs/diffusers/main/en/api/diffusion_pipeline#diffusers.DiffusionPipeline"),c(A,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(B,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(ve,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(E,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(be,"id","diffusers.VersatileDiffusionImageVariationPipeline"),c(be,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(be,"href","#diffusers.VersatileDiffusionImageVariationPipeline"),c(te,"class","relative group"),c(St,"href","/docs/diffusers/main/en/api/diffusion_pipeline#diffusers.DiffusionPipeline"),c(F,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(U,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(we,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(q,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(ye,"id","diffusers.VersatileDiffusionDualGuidedPipeline"),c(ye,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(ye,"href","#diffusers.VersatileDiffusionDualGuidedPipeline"),c(ie,"class","relative group"),c(Mt,"href","/docs/diffusers/main/en/api/diffusion_pipeline#diffusers.DiffusionPipeline"),c(W,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(H,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Pe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(S,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(t,f){e(document.head,g),m(t,$,f),m(t,_,f),e(_,u),e(u,P),D(l,P,null),e(_,h),e(_,Qt),e(Qt,Os),m(t,Fi,f),m(t,ne,f),e(ne,Cs),e(ne,Ve),e(Ve,Ns),e(ne,zs),m(t,Ui,f),m(t,mt,f),e(mt,As),m(t,Wi,f),m(t,gt,f),e(gt,Kt),e(Kt,Bs),m(t,Hi,f),m(t,X,f),e(X,ae),e(ae,Xt),D(Ie,Xt,null),e(X,Fs),e(X,Yt),e(Yt,Us),m(t,Ri,f),m(t,ht,f),e(ht,ke),e(ke,Ws),e(ke,_t),e(_t,Hs),e(ke,Rs),m(t,Qi,f),m(t,Y,f),e(Y,oe),e(oe,Zt),D(Te,Zt,null),e(Y,Qs),e(Y,Jt),e(Jt,Ks),m(t,Ki,f),m(t,L,f),e(L,Xs),e(L,vt),e(vt,Ys),e(L,Zs),e(L,bt),e(bt,Js),e(L,en),e(L,Dt),e(Dt,tn),e(L,sn),e(L,wt),e(wt,nn),m(t,Xi,f),m(t,yt,f),e(yt,ei),e(ei,an),m(t,Yi,f),m(t,xt,f),e(xt,on),m(t,Zi,f),m(t,G,f),e(G,je),e(je,ti),e(ti,rn),e(je,ln),e(je,re),e(re,dn),e(re,ii),e(ii,pn),e(re,cn),e(G,fn),e(G,Ee),e(Ee,si),e(si,un),e(Ee,mn),e(Ee,le),e(le,gn),e(le,ni),e(ni,hn),e(le,_n),e(G,vn),e(G,qe),e(qe,ai),e(ai,bn),e(qe,Dn),e(qe,de),e(de,wn),e(de,oi),e(oi,yn),e(de,xn),m(t,Ji,f),m(t,Z,f),e(Z,pe),e(pe,ri),D(Se,ri,null),e(Z,Pn),e(Z,li),e(li,$n),m(t,es,f),m(t,V,f),e(V,Vn),e(V,Pt),e(Pt,In),e(V,kn),e(V,di),e(di,Tn),e(V,jn),e(V,$t),e($t,En),e(V,qn),e(V,Vt),e(Vt,Sn),e(V,Mn),e(V,It),e(It,Ln),e(V,Gn),e(V,kt),e(kt,On),e(V,Cn),e(V,Tt),e(Tt,Nn),e(V,zn),e(V,pi),e(pi,An),e(V,Bn),e(V,ci),e(ci,Fn),e(V,Un),e(V,jt),e(jt,Wn),e(V,Hn),m(t,ts,f),D(Me,t,f),m(t,is,f),m(t,J,f),e(J,ce),e(ce,fi),D(Le,fi,null),e(J,Rn),e(J,ui),e(ui,Qn),m(t,ss,f),m(t,k,f),D(Ge,k,null),e(k,Kn),e(k,mi),e(mi,Xn),e(k,Yn),e(k,Oe),e(Oe,Zn),e(Oe,Et),e(Et,Jn),e(Oe,ea),e(k,ta),e(k,fe),D(Ce,fe,null),e(fe,ia),e(fe,Ne),e(Ne,sa),e(Ne,gi),e(gi,na),e(Ne,aa),e(k,oa),e(k,O),D(ze,O,null),e(O,ra),e(O,hi),e(hi,la),e(O,da),D(ue,O,null),e(k,pa),e(k,C),D(Ae,C,null),e(C,ca),e(C,_i),e(_i,fa),e(C,ua),e(C,vi),e(vi,ma),e(k,ga),e(k,N),D(Be,N,null),e(N,ha),e(N,bi),e(bi,_a),e(N,va),D(me,N,null),e(k,ba),e(k,z),D(Fe,z,null),e(z,Da),e(z,Di),e(Di,wa),e(z,ya),D(ge,z,null),m(t,ns,f),m(t,ee,f),e(ee,he),e(he,wi),D(Ue,wi,null),e(ee,xa),e(ee,yi),e(yi,Pa),m(t,as,f),m(t,E,f),D(We,E,null),e(E,$a),e(E,He),e(He,Va),e(He,qt),e(qt,Ia),e(He,ka),e(E,Ta),e(E,A),D(Re,A,null),e(A,ja),e(A,xi),e(xi,Ea),e(A,qa),D(_e,A,null),e(E,Sa),e(E,B),D(Qe,B,null),e(B,Ma),e(B,Pi),e(Pi,La),e(B,Ga),e(B,$i),e($i,Oa),e(E,Ca),e(E,ve),D(Ke,ve,null),e(ve,Na),e(ve,Xe),e(Xe,za),e(Xe,Vi),e(Vi,Aa),e(Xe,Ba),m(t,os,f),m(t,te,f),e(te,be),e(be,Ii),D(Ye,Ii,null),e(te,Fa),e(te,ki),e(ki,Ua),m(t,rs,f),m(t,q,f),D(Ze,q,null),e(q,Wa),e(q,Je),e(Je,Ha),e(Je,St),e(St,Ra),e(Je,Qa),e(q,Ka),e(q,F),D(et,F,null),e(F,Xa),e(F,Ti),e(Ti,Ya),e(F,Za),D(De,F,null),e(q,Ja),e(q,U),D(tt,U,null),e(U,eo),e(U,ji),e(ji,to),e(U,io),e(U,Ei),e(Ei,so),e(q,no),e(q,we),D(it,we,null),e(we,ao),e(we,st),e(st,oo),e(st,qi),e(qi,ro),e(st,lo),m(t,ls,f),m(t,ie,f),e(ie,ye),e(ye,Si),D(nt,Si,null),e(ie,po),e(ie,Mi),e(Mi,co),m(t,ds,f),m(t,S,f),D(at,S,null),e(S,fo),e(S,ot),e(ot,uo),e(ot,Mt),e(Mt,mo),e(ot,go),e(S,ho),e(S,W),D(rt,W,null),e(W,_o),e(W,Li),e(Li,vo),e(W,bo),D(xe,W,null),e(S,Do),e(S,H),D(lt,H,null),e(H,wo),e(H,Gi),e(Gi,yo),e(H,xo),e(H,Oi),e(Oi,Po),e(S,$o),e(S,Pe),D(dt,Pe,null),e(Pe,Vo),e(Pe,pt),e(pt,Io),e(pt,Ci),e(Ci,ko),e(pt,To),ps=!0},p(t,[f]){const ct={};f&2&&(ct.$$scope={dirty:f,ctx:t}),ue.$set(ct);const Ni={};f&2&&(Ni.$$scope={dirty:f,ctx:t}),me.$set(Ni);const zi={};f&2&&(zi.$$scope={dirty:f,ctx:t}),ge.$set(zi);const Ai={};f&2&&(Ai.$$scope={dirty:f,ctx:t}),_e.$set(Ai);const ft={};f&2&&(ft.$$scope={dirty:f,ctx:t}),De.$set(ft);const Bi={};f&2&&(Bi.$$scope={dirty:f,ctx:t}),xe.$set(Bi)},i(t){ps||(w(l.$$.fragment,t),w(Ie.$$.fragment,t),w(Te.$$.fragment,t),w(Se.$$.fragment,t),w(Me.$$.fragment,t),w(Le.$$.fragment,t),w(Ge.$$.fragment,t),w(Ce.$$.fragment,t),w(ze.$$.fragment,t),w(ue.$$.fragment,t),w(Ae.$$.fragment,t),w(Be.$$.fragment,t),w(me.$$.fragment,t),w(Fe.$$.fragment,t),w(ge.$$.fragment,t),w(Ue.$$.fragment,t),w(We.$$.fragment,t),w(Re.$$.fragment,t),w(_e.$$.fragment,t),w(Qe.$$.fragment,t),w(Ke.$$.fragment,t),w(Ye.$$.fragment,t),w(Ze.$$.fragment,t),w(et.$$.fragment,t),w(De.$$.fragment,t),w(tt.$$.fragment,t),w(it.$$.fragment,t),w(nt.$$.fragment,t),w(at.$$.fragment,t),w(rt.$$.fragment,t),w(xe.$$.fragment,t),w(lt.$$.fragment,t),w(dt.$$.fragment,t),ps=!0)},o(t){y(l.$$.fragment,t),y(Ie.$$.fragment,t),y(Te.$$.fragment,t),y(Se.$$.fragment,t),y(Me.$$.fragment,t),y(Le.$$.fragment,t),y(Ge.$$.fragment,t),y(Ce.$$.fragment,t),y(ze.$$.fragment,t),y(ue.$$.fragment,t),y(Ae.$$.fragment,t),y(Be.$$.fragment,t),y(me.$$.fragment,t),y(Fe.$$.fragment,t),y(ge.$$.fragment,t),y(Ue.$$.fragment,t),y(We.$$.fragment,t),y(Re.$$.fragment,t),y(_e.$$.fragment,t),y(Qe.$$.fragment,t),y(Ke.$$.fragment,t),y(Ye.$$.fragment,t),y(Ze.$$.fragment,t),y(et.$$.fragment,t),y(De.$$.fragment,t),y(tt.$$.fragment,t),y(it.$$.fragment,t),y(nt.$$.fragment,t),y(at.$$.fragment,t),y(rt.$$.fragment,t),y(xe.$$.fragment,t),y(lt.$$.fragment,t),y(dt.$$.fragment,t),ps=!1},d(t){i(g),t&&i($),t&&i(_),x(l),t&&i(Fi),t&&i(ne),t&&i(Ui),t&&i(mt),t&&i(Wi),t&&i(gt),t&&i(Hi),t&&i(X),x(Ie),t&&i(Ri),t&&i(ht),t&&i(Qi),t&&i(Y),x(Te),t&&i(Ki),t&&i(L),t&&i(Xi),t&&i(yt),t&&i(Yi),t&&i(xt),t&&i(Zi),t&&i(G),t&&i(Ji),t&&i(Z),x(Se),t&&i(es),t&&i(V),t&&i(ts),x(Me,t),t&&i(is),t&&i(J),x(Le),t&&i(ss),t&&i(k),x(Ge),x(Ce),x(ze),x(ue),x(Ae),x(Be),x(me),x(Fe),x(ge),t&&i(ns),t&&i(ee),x(Ue),t&&i(as),t&&i(E),x(We),x(Re),x(_e),x(Qe),x(Ke),t&&i(os),t&&i(te),x(Ye),t&&i(rs),t&&i(q),x(Ze),x(et),x(De),x(tt),x(it),t&&i(ls),t&&i(ie),x(nt),t&&i(ds),t&&i(S),x(at),x(rt),x(xe),x(lt),x(dt)}}}const ol={local:"versatilediffusion",sections:[{local:"tips",sections:[{local:"run-versatilediffusion",title:"*Run VersatileDiffusion*"},{local:"how-to-load-and-use-different-schedulers",title:"*How to load and use different schedulers.*"}],title:"Tips"},{local:"diffusers.VersatileDiffusionPipeline",title:"VersatileDiffusionPipeline"},{local:"diffusers.VersatileDiffusionTextToImagePipeline",title:"VersatileDiffusionTextToImagePipeline"},{local:"diffusers.VersatileDiffusionImageVariationPipeline",title:"VersatileDiffusionImageVariationPipeline"},{local:"diffusers.VersatileDiffusionDualGuidedPipeline",title:"VersatileDiffusionDualGuidedPipeline"}],title:"VersatileDiffusion"};function rl(M){return Zr(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ul extends Qr{constructor(g){super();Kr(this,g,rl,al,Xr,{})}}export{ul as default,ol as metadata};
