import{S as At,i as jt,s as Nt,e as r,k as f,w as C,t,M as Ot,c as a,d as o,m as g,a as i,x as P,h as n,b as m,G as e,g as E,y as k,q as S,o as I,B as L,v as Tt,L as qt}from"../../chunks/vendor-hf-doc-builder.js";import{T as Lt}from"../../chunks/Tip-hf-doc-builder.js";import{D as _e}from"../../chunks/Docstring-hf-doc-builder.js";import{C as Ut}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as Ft}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{E as Jt}from"../../chunks/ExampleCodeBlock-hf-doc-builder.js";function Wt(U){let c,$,d,u,v;return u=new Ut({props:{code:`from diffusers import DDPMScheduler, DDIMScheduler, PNDMScheduler

# Download scheduler from huggingface.co and cache.
scheduler = DDPMScheduler.from_pretrained("google/ddpm-cifar10-32")

# Instantiate DDIM scheduler class with same config as DDPM
scheduler = DDIMScheduler.from_config(scheduler.config)

# Instantiate PNDM scheduler class with same config as DDPM
scheduler = PNDMScheduler.from_config(scheduler.config)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DDPMScheduler, DDIMScheduler, PNDMScheduler

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Download scheduler from huggingface.co and cache.</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>scheduler = DDPMScheduler.from_pretrained(<span class="hljs-string">&quot;google/ddpm-cifar10-32&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Instantiate DDIM scheduler class with same config as DDPM</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>scheduler = DDIMScheduler.from_config(scheduler.config)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Instantiate PNDM scheduler class with same config as DDPM</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>scheduler = PNDMScheduler.from_config(scheduler.config)`}}),{c(){c=r("p"),$=t("Examples:"),d=f(),C(u.$$.fragment)},l(l){c=a(l,"P",{});var p=i(c);$=n(p,"Examples:"),p.forEach(o),d=g(l),P(u.$$.fragment,l)},m(l,p){E(l,c,p),e(c,$),E(l,d,p),k(u,l,p),v=!0},p:qt,i(l){v||(S(u.$$.fragment,l),v=!0)},o(l){I(u.$$.fragment,l),v=!1},d(l){l&&o(c),l&&o(d),L(u,l)}}}function Rt(U){let c,$,d,u,v,l,p,y;return{c(){c=r("p"),$=t("It is required to be logged in ("),d=r("code"),u=t("huggingface-cli login"),v=t(") when you want to use private or "),l=r("a"),p=t(`gated
models`),y=t("."),this.h()},l(O){c=a(O,"P",{});var w=i(c);$=n(w,"It is required to be logged in ("),d=a(w,"CODE",{});var D=i(d);u=n(D,"huggingface-cli login"),D.forEach(o),v=n(w,") when you want to use private or "),l=a(w,"A",{href:!0,rel:!0});var le=i(l);p=n(le,`gated
models`),le.forEach(o),y=n(w,"."),w.forEach(o),this.h()},h(){m(l,"href","https://huggingface.co/docs/hub/models-gated#gated-models"),m(l,"rel","nofollow")},m(O,w){E(O,c,w),e(c,$),e(c,d),e(d,u),e(c,v),e(c,l),e(l,p),e(c,y)},d(O){O&&o(c)}}}function Vt(U){let c,$,d,u,v;return{c(){c=r("p"),$=t("Activate the special "),d=r("a"),u=t("\u201Coffline-mode\u201D"),v=t(` to
use this method in a firewalled environment.`),this.h()},l(l){c=a(l,"P",{});var p=i(c);$=n(p,"Activate the special "),d=a(p,"A",{href:!0,rel:!0});var y=i(d);u=n(y,"\u201Coffline-mode\u201D"),y.forEach(o),v=n(p,` to
use this method in a firewalled environment.`),p.forEach(o),this.h()},h(){m(d,"href","https://huggingface.co/transformers/installation.html#offline-mode"),m(d,"rel","nofollow")},m(l,p){E(l,c,p),e(c,$),e(c,d),e(d,u),e(c,v)},d(l){l&&o(c)}}}function zt(U){let c,$,d,u,v,l,p,y,O,w,D,le,ve,Qe,Xe,Je,h,X,Ye,T,Ze,be,eo,oo,ce,to,no,so,Y,$e,de,ro,ao,we,fe,io,lo,ye,co,fo,M,A,xe,go,ho,Ee,uo,mo,ge,po,_o,vo,F,De,bo,$o,Me,wo,yo,xo,J,Ce,Eo,Do,Pe,Mo,Co,Po,j,ke,ko,So,Se,Io,Lo,Ie,Ao,jo,No,N,Z,Oo,Le,To,qo,W,Uo,x,ee,Fo,Ae,Jo,Wo,R,Ro,V,Vo,z,oe,zo,q,Bo,je,Go,Ho,he,Ko,Qo,Xo,B,te,Yo,Ne,Zo,et,G,ne,ot,Oe,tt,We,H,nt,se,st,rt,Re;return l=new Ft({}),X=new _e({props:{name:"class diffusers.ConfigMixin",anchor:"diffusers.ConfigMixin",parameters:[],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/configuration_utils.py#L74"}}),Z=new _e({props:{name:"from_config",anchor:"diffusers.ConfigMixin.from_config",parameters:[{name:"config",val:": typing.Union[diffusers.configuration_utils.FrozenDict, typing.Dict[str, typing.Any]] = None"},{name:"return_unused_kwargs",val:" = False"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"diffusers.ConfigMixin.from_config.config",description:`<strong>config</strong> (<code>Dict[str, Any]</code>) &#x2014;
A config dictionary from which the Python class will be instantiated. Make sure to only load
configuration files of compatible classes.`,name:"config"},{anchor:"diffusers.ConfigMixin.from_config.return_unused_kwargs",description:`<strong>return_unused_kwargs</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether kwargs that are not consumed by the Python class should be returned or not.`,name:"return_unused_kwargs"},{anchor:"diffusers.ConfigMixin.from_config.kwargs",description:`<strong>kwargs</strong> (remaining dictionary of keyword arguments, <em>optional</em>) &#x2014;
Can be used to update the configuration object (after it being loaded) and initiate the Python class.
<code>**kwargs</code> will be directly passed to the underlying scheduler/model&#x2019;s <code>__init__</code> method and eventually
overwrite same named arguments of <code>config</code>.`,name:"kwargs"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/configuration_utils.py#L140"}}),W=new Jt({props:{anchor:"diffusers.ConfigMixin.from_config.example",$$slots:{default:[Wt]},$$scope:{ctx:U}}}),ee=new _e({props:{name:"load_config",anchor:"diffusers.ConfigMixin.load_config",parameters:[{name:"pretrained_model_name_or_path",val:": typing.Union[str, os.PathLike]"},{name:"return_unused_kwargs",val:" = False"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"diffusers.ConfigMixin.load_config.pretrained_model_name_or_path",description:`<strong>pretrained_model_name_or_path</strong> (<code>str</code> or <code>os.PathLike</code>, <em>optional</em>) &#x2014;
Can be either:</p>
<ul>
<li>A string, the <em>model id</em> of a model repo on huggingface.co. Valid model ids should have an
organization name, like <code>google/ddpm-celebahq-256</code>.</li>
<li>A path to a <em>directory</em> containing model weights saved using <a href="/docs/diffusers/main/en/using-diffusers/configuration#diffusers.ConfigMixin.save_config">save_config()</a>, e.g.,
<code>./my_model_directory/</code>.</li>
</ul>`,name:"pretrained_model_name_or_path"},{anchor:"diffusers.ConfigMixin.load_config.cache_dir",description:`<strong>cache_dir</strong> (<code>Union[str, os.PathLike]</code>, <em>optional</em>) &#x2014;
Path to a directory in which a downloaded pretrained model configuration should be cached if the
standard cache should not be used.`,name:"cache_dir"},{anchor:"diffusers.ConfigMixin.load_config.force_download",description:`<strong>force_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to force the (re-)download of the model weights and configuration files, overriding the
cached versions if they exist.`,name:"force_download"},{anchor:"diffusers.ConfigMixin.load_config.resume_download",description:`<strong>resume_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to delete incompletely received files. Will attempt to resume the download if such a
file exists.`,name:"resume_download"},{anchor:"diffusers.ConfigMixin.load_config.proxies",description:`<strong>proxies</strong> (<code>Dict[str, str]</code>, <em>optional</em>) &#x2014;
A dictionary of proxy servers to use by protocol or endpoint, e.g., <code>{&apos;http&apos;: &apos;foo.bar:3128&apos;, &apos;http://hostname&apos;: &apos;foo.bar:4012&apos;}</code>. The proxies are used on each request.`,name:"proxies"},{anchor:"diffusers.ConfigMixin.load_config.output_loading_info(bool,",description:`<strong>output_loading_info(<code>bool</code>,</strong> <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to also return a dictionary containing missing keys, unexpected keys and error messages.`,name:"output_loading_info(bool,"},{anchor:"diffusers.ConfigMixin.load_config.local_files_only(bool,",description:`<strong>local_files_only(<code>bool</code>,</strong> <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to only look at local files (i.e., do not try to download the model).`,name:"local_files_only(bool,"},{anchor:"diffusers.ConfigMixin.load_config.use_auth_token",description:`<strong>use_auth_token</strong> (<code>str</code> or <em>bool</em>, <em>optional</em>) &#x2014;
The token to use as HTTP bearer authorization for remote files. If <code>True</code>, will use the token generated
when running <code>transformers-cli login</code> (stored in <code>~/.huggingface</code>).`,name:"use_auth_token"},{anchor:"diffusers.ConfigMixin.load_config.revision",description:`<strong>revision</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;main&quot;</code>) &#x2014;
The specific model version to use. It can be a branch name, a tag name, or a commit id, since we use a
git-based system for storing models and other artifacts on huggingface.co, so <code>revision</code> can be any
identifier allowed by git.`,name:"revision"},{anchor:"diffusers.ConfigMixin.load_config.subfolder",description:`<strong>subfolder</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;&quot;</code>) &#x2014;
In case the relevant files are located inside a subfolder of the model repo (either remote in
huggingface.co or downloaded locally), you can specify the folder name here.`,name:"subfolder"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/configuration_utils.py#L232"}}),R=new Lt({props:{$$slots:{default:[Rt]},$$scope:{ctx:U}}}),V=new Lt({props:{$$slots:{default:[Vt]},$$scope:{ctx:U}}}),oe=new _e({props:{name:"save_config",anchor:"diffusers.ConfigMixin.save_config",parameters:[{name:"save_directory",val:": typing.Union[str, os.PathLike]"},{name:"push_to_hub",val:": bool = False"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"diffusers.ConfigMixin.save_config.save_directory",description:`<strong>save_directory</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
Directory where the configuration JSON file will be saved (will be created if it does not exist).`,name:"save_directory"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/configuration_utils.py#L120"}}),te=new _e({props:{name:"to_json_file",anchor:"diffusers.ConfigMixin.to_json_file",parameters:[{name:"json_file_path",val:": typing.Union[str, os.PathLike]"}],parametersDescription:[{anchor:"diffusers.ConfigMixin.to_json_file.json_file_path",description:`<strong>json_file_path</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
Path to the JSON file in which this configuration instance&#x2019;s parameters will be saved.`,name:"json_file_path"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/configuration_utils.py#L515"}}),ne=new _e({props:{name:"to_json_string",anchor:"diffusers.ConfigMixin.to_json_string",parameters:[],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/configuration_utils.py#L496",returnDescription:`
<p>String containing all the attributes that make up this configuration instance in JSON format.</p>
`,returnType:`
<p><code>str</code></p>
`}}),{c(){c=r("meta"),$=f(),d=r("h1"),u=r("a"),v=r("span"),C(l.$$.fragment),p=f(),y=r("span"),O=t("Configuration"),w=f(),D=r("p"),le=t("The handling of configurations in Diffusers is with the "),ve=r("code"),Qe=t("ConfigMixin"),Xe=t(" class."),Je=f(),h=r("div"),C(X.$$.fragment),Ye=f(),T=r("p"),Ze=t("Base class for all configuration classes. Stores all configuration parameters under "),be=r("code"),eo=t("self.config"),oo=t(` Also handles all
methods for loading/downloading/saving classes inheriting from `),ce=r("a"),to=t("ConfigMixin"),no=t(" with"),so=f(),Y=r("ul"),$e=r("li"),de=r("a"),ro=t("from_config()"),ao=f(),we=r("li"),fe=r("a"),io=t("save_config()"),lo=f(),ye=r("p"),co=t("Class attributes:"),fo=f(),M=r("ul"),A=r("li"),xe=r("strong"),go=t("config_name"),ho=t(" ("),Ee=r("code"),uo=t("str"),mo=t(`) \u2014 A filename under which the config should stored when calling
`),ge=r("a"),po=t("save_config()"),_o=t(" (should be overridden by parent class)."),vo=f(),F=r("li"),De=r("strong"),bo=t("ignore_for_config"),$o=t(" ("),Me=r("code"),wo=t("List[str]"),yo=t(`) \u2014 A list of attributes that should not be saved in the config (should be
overridden by subclass).`),xo=f(),J=r("li"),Ce=r("strong"),Eo=t("has_compatibles"),Do=t(" ("),Pe=r("code"),Mo=t("bool"),Co=t(") \u2014 Whether the class has compatible classes (should be overridden by subclass)."),Po=f(),j=r("li"),ke=r("strong"),ko=t("_deprecated_kwargs"),So=t(" ("),Se=r("code"),Io=t("List[str]"),Lo=t(`) \u2014 Keyword arguments that are deprecated. Note that the init function
should only have a `),Ie=r("code"),Ao=t("kwargs"),jo=t(` argument if at least one argument is deprecated (should be overridden by
subclass).`),No=f(),N=r("div"),C(Z.$$.fragment),Oo=f(),Le=r("p"),To=t("Instantiate a Python class from a config dictionary"),qo=f(),C(W.$$.fragment),Uo=f(),x=r("div"),C(ee.$$.fragment),Fo=f(),Ae=r("p"),Jo=t("Instantiate a Python class from a config dictionary"),Wo=f(),C(R.$$.fragment),Ro=f(),C(V.$$.fragment),Vo=f(),z=r("div"),C(oe.$$.fragment),zo=f(),q=r("p"),Bo=t("Save a configuration object to the directory "),je=r("code"),Go=t("save_directory"),Ho=t(`, so that it can be re-loaded using the
`),he=r("a"),Ko=t("from_config()"),Qo=t(" class method."),Xo=f(),B=r("div"),C(te.$$.fragment),Yo=f(),Ne=r("p"),Zo=t("Save this instance to a JSON file."),et=f(),G=r("div"),C(ne.$$.fragment),ot=f(),Oe=r("p"),tt=t("Serializes this instance to a JSON string."),We=f(),H=r("p"),nt=t("Under further construction \u{1F6A7}, open a "),se=r("a"),st=t("PR"),rt=t(" if you want to contribute!"),this.h()},l(s){const b=Ot('[data-svelte="svelte-1phssyn"]',document.head);c=a(b,"META",{name:!0,content:!0}),b.forEach(o),$=g(s),d=a(s,"H1",{class:!0});var re=i(d);u=a(re,"A",{id:!0,class:!0,href:!0});var Te=i(u);v=a(Te,"SPAN",{});var qe=i(v);P(l.$$.fragment,qe),qe.forEach(o),Te.forEach(o),p=g(re),y=a(re,"SPAN",{});var at=i(y);O=n(at,"Configuration"),at.forEach(o),re.forEach(o),w=g(s),D=a(s,"P",{});var Ve=i(D);le=n(Ve,"The handling of configurations in Diffusers is with the "),ve=a(Ve,"CODE",{});var it=i(ve);Qe=n(it,"ConfigMixin"),it.forEach(o),Xe=n(Ve," class."),Ve.forEach(o),Je=g(s),h=a(s,"DIV",{class:!0});var _=i(h);P(X.$$.fragment,_),Ye=g(_),T=a(_,"P",{});var ue=i(T);Ze=n(ue,"Base class for all configuration classes. Stores all configuration parameters under "),be=a(ue,"CODE",{});var lt=i(be);eo=n(lt,"self.config"),lt.forEach(o),oo=n(ue,` Also handles all
methods for loading/downloading/saving classes inheriting from `),ce=a(ue,"A",{href:!0});var ct=i(ce);to=n(ct,"ConfigMixin"),ct.forEach(o),no=n(ue," with"),ue.forEach(o),so=g(_),Y=a(_,"UL",{});var ze=i(Y);$e=a(ze,"LI",{});var dt=i($e);de=a(dt,"A",{href:!0});var ft=i(de);ro=n(ft,"from_config()"),ft.forEach(o),dt.forEach(o),ao=g(ze),we=a(ze,"LI",{});var gt=i(we);fe=a(gt,"A",{href:!0});var ht=i(fe);io=n(ht,"save_config()"),ht.forEach(o),gt.forEach(o),ze.forEach(o),lo=g(_),ye=a(_,"P",{});var ut=i(ye);co=n(ut,"Class attributes:"),ut.forEach(o),fo=g(_),M=a(_,"UL",{});var K=i(M);A=a(K,"LI",{});var ae=i(A);xe=a(ae,"STRONG",{});var mt=i(xe);go=n(mt,"config_name"),mt.forEach(o),ho=n(ae," ("),Ee=a(ae,"CODE",{});var pt=i(Ee);uo=n(pt,"str"),pt.forEach(o),mo=n(ae,`) \u2014 A filename under which the config should stored when calling
`),ge=a(ae,"A",{href:!0});var _t=i(ge);po=n(_t,"save_config()"),_t.forEach(o),_o=n(ae," (should be overridden by parent class)."),ae.forEach(o),vo=g(K),F=a(K,"LI",{});var Ue=i(F);De=a(Ue,"STRONG",{});var vt=i(De);bo=n(vt,"ignore_for_config"),vt.forEach(o),$o=n(Ue," ("),Me=a(Ue,"CODE",{});var bt=i(Me);wo=n(bt,"List[str]"),bt.forEach(o),yo=n(Ue,`) \u2014 A list of attributes that should not be saved in the config (should be
overridden by subclass).`),Ue.forEach(o),xo=g(K),J=a(K,"LI",{});var Fe=i(J);Ce=a(Fe,"STRONG",{});var $t=i(Ce);Eo=n($t,"has_compatibles"),$t.forEach(o),Do=n(Fe," ("),Pe=a(Fe,"CODE",{});var wt=i(Pe);Mo=n(wt,"bool"),wt.forEach(o),Co=n(Fe,") \u2014 Whether the class has compatible classes (should be overridden by subclass)."),Fe.forEach(o),Po=g(K),j=a(K,"LI",{});var ie=i(j);ke=a(ie,"STRONG",{});var yt=i(ke);ko=n(yt,"_deprecated_kwargs"),yt.forEach(o),So=n(ie," ("),Se=a(ie,"CODE",{});var xt=i(Se);Io=n(xt,"List[str]"),xt.forEach(o),Lo=n(ie,`) \u2014 Keyword arguments that are deprecated. Note that the init function
should only have a `),Ie=a(ie,"CODE",{});var Et=i(Ie);Ao=n(Et,"kwargs"),Et.forEach(o),jo=n(ie,` argument if at least one argument is deprecated (should be overridden by
subclass).`),ie.forEach(o),K.forEach(o),No=g(_),N=a(_,"DIV",{class:!0});var me=i(N);P(Z.$$.fragment,me),Oo=g(me),Le=a(me,"P",{});var Dt=i(Le);To=n(Dt,"Instantiate a Python class from a config dictionary"),Dt.forEach(o),qo=g(me),P(W.$$.fragment,me),me.forEach(o),Uo=g(_),x=a(_,"DIV",{class:!0});var Q=i(x);P(ee.$$.fragment,Q),Fo=g(Q),Ae=a(Q,"P",{});var Mt=i(Ae);Jo=n(Mt,"Instantiate a Python class from a config dictionary"),Mt.forEach(o),Wo=g(Q),P(R.$$.fragment,Q),Ro=g(Q),P(V.$$.fragment,Q),Q.forEach(o),Vo=g(_),z=a(_,"DIV",{class:!0});var Be=i(z);P(oe.$$.fragment,Be),zo=g(Be),q=a(Be,"P",{});var pe=i(q);Bo=n(pe,"Save a configuration object to the directory "),je=a(pe,"CODE",{});var Ct=i(je);Go=n(Ct,"save_directory"),Ct.forEach(o),Ho=n(pe,`, so that it can be re-loaded using the
`),he=a(pe,"A",{href:!0});var Pt=i(he);Ko=n(Pt,"from_config()"),Pt.forEach(o),Qo=n(pe," class method."),pe.forEach(o),Be.forEach(o),Xo=g(_),B=a(_,"DIV",{class:!0});var Ge=i(B);P(te.$$.fragment,Ge),Yo=g(Ge),Ne=a(Ge,"P",{});var kt=i(Ne);Zo=n(kt,"Save this instance to a JSON file."),kt.forEach(o),Ge.forEach(o),et=g(_),G=a(_,"DIV",{class:!0});var He=i(G);P(ne.$$.fragment,He),ot=g(He),Oe=a(He,"P",{});var St=i(Oe);tt=n(St,"Serializes this instance to a JSON string."),St.forEach(o),He.forEach(o),_.forEach(o),We=g(s),H=a(s,"P",{});var Ke=i(H);nt=n(Ke,"Under further construction \u{1F6A7}, open a "),se=a(Ke,"A",{href:!0,rel:!0});var It=i(se);st=n(It,"PR"),It.forEach(o),rt=n(Ke," if you want to contribute!"),Ke.forEach(o),this.h()},h(){m(c,"name","hf:doc:metadata"),m(c,"content",JSON.stringify(Bt)),m(u,"id","diffusers.ConfigMixin"),m(u,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(u,"href","#diffusers.ConfigMixin"),m(d,"class","relative group"),m(ce,"href","/docs/diffusers/main/en/using-diffusers/configuration#diffusers.ConfigMixin"),m(de,"href","/docs/diffusers/main/en/using-diffusers/configuration#diffusers.ConfigMixin.from_config"),m(fe,"href","/docs/diffusers/main/en/using-diffusers/configuration#diffusers.ConfigMixin.save_config"),m(ge,"href","/docs/diffusers/main/en/using-diffusers/configuration#diffusers.ConfigMixin.save_config"),m(N,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(x,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(he,"href","/docs/diffusers/main/en/using-diffusers/configuration#diffusers.ConfigMixin.from_config"),m(z,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(B,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(G,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(h,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(se,"href","https://github.com/huggingface/diffusers/compare"),m(se,"rel","nofollow")},m(s,b){e(document.head,c),E(s,$,b),E(s,d,b),e(d,u),e(u,v),k(l,v,null),e(d,p),e(d,y),e(y,O),E(s,w,b),E(s,D,b),e(D,le),e(D,ve),e(ve,Qe),e(D,Xe),E(s,Je,b),E(s,h,b),k(X,h,null),e(h,Ye),e(h,T),e(T,Ze),e(T,be),e(be,eo),e(T,oo),e(T,ce),e(ce,to),e(T,no),e(h,so),e(h,Y),e(Y,$e),e($e,de),e(de,ro),e(Y,ao),e(Y,we),e(we,fe),e(fe,io),e(h,lo),e(h,ye),e(ye,co),e(h,fo),e(h,M),e(M,A),e(A,xe),e(xe,go),e(A,ho),e(A,Ee),e(Ee,uo),e(A,mo),e(A,ge),e(ge,po),e(A,_o),e(M,vo),e(M,F),e(F,De),e(De,bo),e(F,$o),e(F,Me),e(Me,wo),e(F,yo),e(M,xo),e(M,J),e(J,Ce),e(Ce,Eo),e(J,Do),e(J,Pe),e(Pe,Mo),e(J,Co),e(M,Po),e(M,j),e(j,ke),e(ke,ko),e(j,So),e(j,Se),e(Se,Io),e(j,Lo),e(j,Ie),e(Ie,Ao),e(j,jo),e(h,No),e(h,N),k(Z,N,null),e(N,Oo),e(N,Le),e(Le,To),e(N,qo),k(W,N,null),e(h,Uo),e(h,x),k(ee,x,null),e(x,Fo),e(x,Ae),e(Ae,Jo),e(x,Wo),k(R,x,null),e(x,Ro),k(V,x,null),e(h,Vo),e(h,z),k(oe,z,null),e(z,zo),e(z,q),e(q,Bo),e(q,je),e(je,Go),e(q,Ho),e(q,he),e(he,Ko),e(q,Qo),e(h,Xo),e(h,B),k(te,B,null),e(B,Yo),e(B,Ne),e(Ne,Zo),e(h,et),e(h,G),k(ne,G,null),e(G,ot),e(G,Oe),e(Oe,tt),E(s,We,b),E(s,H,b),e(H,nt),e(H,se),e(se,st),e(H,rt),Re=!0},p(s,[b]){const re={};b&2&&(re.$$scope={dirty:b,ctx:s}),W.$set(re);const Te={};b&2&&(Te.$$scope={dirty:b,ctx:s}),R.$set(Te);const qe={};b&2&&(qe.$$scope={dirty:b,ctx:s}),V.$set(qe)},i(s){Re||(S(l.$$.fragment,s),S(X.$$.fragment,s),S(Z.$$.fragment,s),S(W.$$.fragment,s),S(ee.$$.fragment,s),S(R.$$.fragment,s),S(V.$$.fragment,s),S(oe.$$.fragment,s),S(te.$$.fragment,s),S(ne.$$.fragment,s),Re=!0)},o(s){I(l.$$.fragment,s),I(X.$$.fragment,s),I(Z.$$.fragment,s),I(W.$$.fragment,s),I(ee.$$.fragment,s),I(R.$$.fragment,s),I(V.$$.fragment,s),I(oe.$$.fragment,s),I(te.$$.fragment,s),I(ne.$$.fragment,s),Re=!1},d(s){o(c),s&&o($),s&&o(d),L(l),s&&o(w),s&&o(D),s&&o(Je),s&&o(h),L(X),L(Z),L(W),L(ee),L(R),L(V),L(oe),L(te),L(ne),s&&o(We),s&&o(H)}}}const Bt={local:"diffusers.ConfigMixin",title:"Configuration"};function Gt(U){return Tt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class en extends At{constructor(c){super();jt(this,c,Gt,zt,Nt,{})}}export{en as default,Bt as metadata};
